// BcasCardReader.cpp: B-CASJ[h[_NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include <Memory>
#include "TsDataEncode.h"
#include "BcasCardReader.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#pragma comment(lib, "WinScard.lib")


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME	TEXT("B-CAS ėpX}[gJ[h[_")


/////////////////////////////////////////////////////////////////////////////
// ėpX}[gJ[h[_p B-CASJ[hC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

const BONGUID CBcasCardReader::GetDeviceType(void)
{
	// foCX̃^CvԂ
	return ::BonClassNameToGuid(TEXT("IHalBcasCard"));
}

const DWORD CBcasCardReader::GetDeviceName(LPTSTR lpszName)
{
	// foCXԂ
	if(lpszName)::lstrcpy(lpszName, DEVICENAME);

	return ::lstrlen(DEVICENAME);
}

const DWORD CBcasCardReader::GetTotalDeviceNum(void)
{
	// B-CASJ[h}ĂJ[h[_Ԃ

	// X}[gJ[h[_
	if(!EnumBcasCardReader())return 0UL;
	
	SCARDHANDLE hBcasCard;
	DWORD dwBcasCardNum = 0UL;
	DWORD dwActiveProtocol;
	
	// s
	for(DWORD dwIndex = 0UL ; dwIndex < m_CardReaderArray.size() ; dwIndex++){

		hBcasCard = NULL;
		dwActiveProtocol = SCARD_PROTOCOL_UNDEFINED;

		// J[h[_ɐڑ
		if(::SCardConnect(m_ScardContext, m_CardReaderArray[dwIndex].c_str(), SCARD_SHARE_SHARED, SCARD_PROTOCOL_T1, &hBcasCard, &dwActiveProtocol) == SCARD_S_SUCCESS){
			// vgR`FbN
			if(dwActiveProtocol == SCARD_PROTOCOL_T1){
				// R}hM
				if(InitialSetting(hBcasCard)){
					// B-CASJ[hCNg
					dwBcasCardNum++;
					}
				}
			// J[h[_ؒf
			::SCardDisconnect(hBcasCard, SCARD_LEAVE_CARD);	
			}
		}

	return dwBcasCardNum;
}

const DWORD CBcasCardReader::GetActiveDeviceNum(void)
{
	// X}[gJ[h[_͋p\Ȃߏ0Ԃ
	return 0UL;
}

const bool CBcasCardReader::OpenCard(void)
{
	// UN[Y
	CloseCard();

	// X}[gJ[h[_
	if(!EnumBcasCardReader())return false;

	DWORD dwActiveProtocol;
	
	// s
	for(DWORD dwIndex = 0UL ; dwIndex < m_CardReaderArray.size() ; dwIndex++){

		m_hBcasCard = NULL;
		dwActiveProtocol = SCARD_PROTOCOL_UNDEFINED;

		// J[h[_ɐڑ
		if(::SCardConnect(m_ScardContext, m_CardReaderArray[dwIndex].c_str(), SCARD_SHARE_SHARED, SCARD_PROTOCOL_T1, &m_hBcasCard, &dwActiveProtocol) == SCARD_S_SUCCESS){
			// vgR`FbN
			if(dwActiveProtocol == SCARD_PROTOCOL_T1){
				// R}hM
				if(InitialSetting(m_hBcasCard)){
					// B-CASJ[hCNg
					break;
					}
				}

			// J[h[_ؒf
			::SCardDisconnect(m_hBcasCard, SCARD_LEAVE_CARD);
			m_hBcasCard = NULL;
			}
		}

	return (m_hBcasCard)? true : false;
}

void CBcasCardReader::CloseCard(void)
{
	// J[h[_ؒf
	if(m_hBcasCard){
		::SCardDisconnect(m_hBcasCard, SCARD_LEAVE_CARD);
		m_hBcasCard = NULL;
		}
}

const bool CBcasCardReader::IsInteractive(void)
{
	// oʐM̉ۂԂ
	return true;
}

const BYTE * CBcasCardReader::GetBcasCardID(void)
{
	// Card ID Ԃ
	return (m_hBcasCard)? m_BcasCardInfo.BcasCardID : NULL;
}

const BYTE * CBcasCardReader::GetInitialCbc(void)
{
	// Descrambler CBC Initial Value Ԃ
	return (m_hBcasCard)? m_BcasCardInfo.InitialCbc : NULL;
}

const BYTE * CBcasCardReader::GetSystemKey(void)
{
	// Descrambling System Key Ԃ
	return (m_hBcasCard)? m_BcasCardInfo.SystemKey : NULL;
}

const BYTE * CBcasCardReader::GetKsFromEcm(const BYTE *pEcmData, const DWORD dwEcmSize)
{
	static const BYTE abyEcmReceiveCmd[] = {0x90U, 0x34U, 0x00U, 0x00U};

	// uECM Receive Commandv
	if(!m_hBcasCard){
		m_dwEcmError = EC_NO_ERROR;
		return NULL;
		}

	// ECMTCY`FbN
	if(!pEcmData || (dwEcmSize < 30UL) || (dwEcmSize > 256UL)){
		m_dwEcmError = EC_BADARGUMENT;
		return NULL;
		}

	// obt@
	DWORD dwRecvSize = 0UL;
	BYTE SendData[1024];
	BYTE RecvData[1024];
	::ZeroMemory(RecvData, sizeof(RecvData));

	// R}h\z
	::CopyMemory(SendData, abyEcmReceiveCmd, sizeof(abyEcmReceiveCmd));			// CLA, INS, P1, P2
	SendData[sizeof(abyEcmReceiveCmd)] = (BYTE)dwEcmSize;						// COMMAND DATA LENGTH
	::CopyMemory(&SendData[sizeof(abyEcmReceiveCmd) + 1], pEcmData, dwEcmSize);	// ECM
	SendData[sizeof(abyEcmReceiveCmd) + dwEcmSize + 1] = 0x00U;					// RESPONSE DATA LENGTH

	// R}hM
	if(!TransmitCommand(m_hBcasCard, SendData, sizeof(abyEcmReceiveCmd) + dwEcmSize + 2UL, RecvData, sizeof(RecvData), &dwRecvSize)){
		::ZeroMemory(&m_EcmStatus, sizeof(m_EcmStatus));
		m_dwEcmError = EC_TRANSMIT_ERROR;
		return NULL;
		}

	// TCY`FbN
	if(dwRecvSize != 25UL){
		::ZeroMemory(&m_EcmStatus, sizeof(m_EcmStatus));
		m_dwEcmError = EC_TRANSMIT_ERROR;
		return NULL;
		}	
	
	// X|X
	::CopyMemory(m_EcmStatus.KsData, &RecvData[6], sizeof(m_EcmStatus.KsData));

	// ^[R[h
	switch(((WORD)RecvData[4] << 8) | (WORD)RecvData[5]){
		// wς: 
		case 0x0200U :	// 㕥PPV
		case 0x0400U :	// OPPV
		case 0x0800U :	// eBA
		
		// w: vr[
		case 0x4480U :	// 㕥PPV
		case 0x4280U :	// OPPV
			m_dwEcmError = EC_NO_ERROR;
			return m_EcmStatus.KsData;
		
		// LȊO(s)
		default :
			m_dwEcmError = EC_NOT_CONTRACTED;
			return NULL;
		}
}

const DWORD CBcasCardReader::GetEcmError(void) const
{
	// ECMG[R[hԂ
	return m_dwEcmError;
}

const bool CBcasCardReader::SendEmmSection(const BYTE *pEmmData, const DWORD dwEmmSize)
{
	static const BYTE abyEmmReceiveCmd[] = {0x90U, 0x36U, 0x00U, 0x00U};

	// uEMM Receive Commandv
	if(!m_hBcasCard)return false;

	// EMMTCY`FbN
	if(!pEmmData || (dwEmmSize < 17UL) || (dwEmmSize > 263UL))return false;

	// obt@
	DWORD dwRecvSize = 0UL;
	BYTE SendData[1024];
	BYTE RecvData[1024];
	::ZeroMemory(RecvData, sizeof(RecvData));

	// R}h\z
	::CopyMemory(SendData, abyEmmReceiveCmd, sizeof(abyEmmReceiveCmd));			// CLA, INS, P1, P2
	SendData[sizeof(abyEmmReceiveCmd)] = (BYTE)dwEmmSize;						// COMMAND DATA LENGTH
	::CopyMemory(&SendData[sizeof(abyEmmReceiveCmd) + 1], pEmmData, dwEmmSize);	// EMM
	SendData[sizeof(abyEmmReceiveCmd) + dwEmmSize + 1] = 0x00U;					// RESPONSE DATA LENGTH

	// R}hM
	if(!TransmitCommand(m_hBcasCard, SendData, sizeof(abyEmmReceiveCmd) + dwEmmSize + 2UL, RecvData, sizeof(RecvData), &dwRecvSize))return false;

	// TCY`FbN
	if(dwRecvSize != 8UL)return false;
	
	// ^[R[h
	switch(((WORD)RecvData[4] << 8) | (WORD)RecvData[5]){
		case 0x2100U :	// I
			return true;

		case 0xA102U :	// ^p(^pOvgRԍ)
		case 0xA107U :	// ZLeBG[(EMMG[)
			return false;
		
		// LȊO(O)
		default :
			return false;
		}
}

const WORD CBcasCardReader::GetPowerCtrlInfo(POWERCTRLINFO *pPowerCtrlInfo)
{
	BYTE abyReqPowerCtrlCmd[] = {0x90U, 0x80U, 0x00U, 0x00U, 0x01U, 0x00U, 0x00U};

	// ʓd擾
	if(!m_hBcasCard)return 0U;

	// obt@
	DWORD dwRecvSize = 0UL;
	BYTE RecvData[1024];
	::ZeroMemory(RecvData, sizeof(RecvData));

	// R}hM
	if(!TransmitCommand(m_hBcasCard, abyReqPowerCtrlCmd, sizeof(abyReqPowerCtrlCmd), RecvData, sizeof(RecvData), &dwRecvSize))return 0U;

	// MTCY`FbN
	if(dwRecvSize != 20UL)return 0U;		

	// ^[R[h
	if((((WORD)RecvData[4] << 8) | (WORD)RecvData[5]) != 0x2100U)return 0U;

	// X|X
	const WORD wInfoNum = (WORD)RecvData[7] + 1U;
	if(!pPowerCtrlInfo)return wInfoNum;		// NULL̂Ƃ͕Kvȃobt@Ԃ

	CTsTime TsTime;

	for(WORD wIndex = 0U ; wIndex < wInfoNum ; wIndex++){
		// R}hݒ
		abyReqPowerCtrlCmd[5] = (BYTE)wIndex;

		// R}hM
		if(!TransmitCommand(m_hBcasCard, abyReqPowerCtrlCmd, sizeof(abyReqPowerCtrlCmd), RecvData, sizeof(RecvData), &dwRecvSize))return 0U;

		// MTCY`FbN
		if(dwRecvSize != 20UL)return 0U;		

		// ^[R[h
		if((((WORD)RecvData[4] << 8) | (WORD)RecvData[5]) != 0x2100U)return 0U;
		
		// X|X
		TsTime.ClearTime();
		CAribTime::SplitAribMjd(((WORD)RecvData[9] << 8) | (WORD)RecvData[10], &TsTime.wYear, &TsTime.wMonth, &TsTime.wDay, &TsTime.wDayOfWeek);
		TsTime -= (DWORD)RecvData[11] * 24UL * 60UL * 60UL;
		pPowerCtrlInfo[wIndex].stStartTime = TsTime;
		TsTime += (DWORD)RecvData[12] * 24UL * 60UL * 60UL;
		pPowerCtrlInfo[wIndex].stEndTime = TsTime;
		pPowerCtrlInfo[wIndex].byDurTime = RecvData[13];
		pPowerCtrlInfo[wIndex].wNtID = (((WORD)RecvData[14] << 8) | (WORD)RecvData[15]);
		pPowerCtrlInfo[wIndex].wTsID = (((WORD)RecvData[16] << 8) | (WORD)RecvData[17]);
		}

	return wInfoNum;
}

CBcasCardReader::CBcasCardReader(IBonObject * const pOwner)
	: CBonObject(pOwner)
	, m_ScardContext(NULL)
	, m_hBcasCard(NULL)
	, m_dwEcmError(EC_NOT_OPEN)
{
	// ԏ
	::ZeroMemory(&m_BcasCardInfo, sizeof(m_BcasCardInfo));
	::ZeroMemory(&m_EcmStatus, sizeof(m_EcmStatus));

	// \[X}l[WReLXgm
	::SCardEstablishContext(SCARD_SCOPE_USER, NULL, NULL, &m_ScardContext);
}

CBcasCardReader::~CBcasCardReader(void)
{
	CloseCard();

	// \[X}l[WReLXg̊J
	if(m_ScardContext)::SCardReleaseContext(m_ScardContext);
}

const bool CBcasCardReader::EnumBcasCardReader(void)
{
	// J[h[_񋓂
	DWORD dwBuffSize = 0UL;
	
	// obt@TCY擾
	if(::SCardListReaders(m_ScardContext, NULL, NULL, &dwBuffSize) != SCARD_S_SUCCESS)return false;

	// obt@m
	std::auto_ptr<TCHAR> szReaders(new TCHAR[dwBuffSize]);

	// J[h[_
	if(::SCardListReaders(m_ScardContext, NULL, szReaders.get(), &dwBuffSize) != SCARD_S_SUCCESS)return false;

	// J[h[_ۑ
	LPTSTR lpszCurReader = szReaders.get();
	m_CardReaderArray.clear();
			
	while(*lpszCurReader){
		m_CardReaderArray.push_back(lpszCurReader);
		lpszCurReader += m_CardReaderArray.back().length() + 1UL;
		}

	return (m_CardReaderArray.size())? true : false;
}

const bool CBcasCardReader::TransmitCommand(const SCARDHANDLE hBcasCard, const BYTE *pSendData, const DWORD dwSendSize, BYTE *pRecvData, const DWORD dwMaxRecv, DWORD *pdwRecvSize)
{
	DWORD dwRecvSize = dwMaxRecv;

	// f[^M
	DWORD dwReturn = ::SCardTransmit(hBcasCard, SCARD_PCI_T1, pSendData, dwSendSize, NULL, pRecvData, &dwRecvSize);
	
	// MTCYi[
	if(pdwRecvSize)*pdwRecvSize = dwRecvSize;

	return (dwReturn == SCARD_S_SUCCESS)? true : false;
}

const bool CBcasCardReader::InitialSetting(const SCARDHANDLE hBcasCard)
{
	static const BYTE abyInitSettingCmd[] = {0x90U, 0x30U, 0x00U, 0x00U, 0x00U};

	// uInitial Setting Conditions Commandv
	if(!hBcasCard)return false;

	// obt@
	DWORD dwRecvSize = 0UL;
	BYTE RecvData[1024];
	::ZeroMemory(RecvData, sizeof(RecvData));
	
	// R}hM
	if(!TransmitCommand(hBcasCard, abyInitSettingCmd, sizeof(abyInitSettingCmd), RecvData, sizeof(RecvData), &dwRecvSize))return false;

	// MTCY`FbN
	if(dwRecvSize < 57UL)return false;		

	// X|X
	::CopyMemory(m_BcasCardInfo.BcasCardID, &RecvData[8],   6UL);	// +8	Card ID
	::CopyMemory(m_BcasCardInfo.SystemKey,  &RecvData[16], 32UL);	// +16	Descrambling system key
	::CopyMemory(m_BcasCardInfo.InitialCbc, &RecvData[48],  8UL);	// +48	Descrambler CBC initial value

	// ECMXe[^X
	::ZeroMemory(&m_EcmStatus, sizeof(m_EcmStatus));

	return true;
}
