// SyncObject.cpp: IuWFNgbp[NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "SyncObject.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// NeBJZNVbp[NX
//////////////////////////////////////////////////////////////////////

CSmartLock::CSmartLock()
{
	// NeBJZNV
	::InitializeCriticalSection(&m_CriticalSection);
}

CSmartLock::~CSmartLock()
{
	// NeBJZNV폜
	::DeleteCriticalSection(&m_CriticalSection);
}

void CSmartLock::Lock(void)
{
	// NeBJZNV擾
	::EnterCriticalSection(&m_CriticalSection);
}

void CSmartLock::Unlock(void)
{
	// NeBJZNVJ
	::LeaveCriticalSection(&m_CriticalSection);
}
	
	
//////////////////////////////////////////////////////////////////////
// ubNXR[vbNNX
//////////////////////////////////////////////////////////////////////
	
CBlockLock::CBlockLock(CSmartLock *pSmartLock)
	: m_pSmartLock(pSmartLock)
{
	// bN擾
	if(m_pSmartLock)m_pSmartLock->Lock();
}

CBlockLock::~CBlockLock()
{
	// bNJ
	if(m_pSmartLock)m_pSmartLock->Unlock();
}


//////////////////////////////////////////////////////////////////////
// Cxgbp[NX
//////////////////////////////////////////////////////////////////////

CSmartEvent::CSmartEvent(const bool bManualReset, const bool bInitialState)
	: m_hEvent(NULL)
{
	// Cxg쐬
	m_hEvent = ::CreateEvent(NULL, (bManualReset)? TRUE : FALSE, (bInitialState)? TRUE : FALSE, NULL);
}

CSmartEvent::~CSmartEvent(void)
{
	// CxgJ
	if(m_hEvent)::CloseHandle(m_hEvent);
}

const bool CSmartEvent::SetEvent(void)
{
	// CxgZbg
	return (::SetEvent(m_hEvent))? true : false;
}

const bool CSmartEvent::PulseEvent(void)
{
	// CxgZbg(1̃Xbĥ݊J)
	return (::PulseEvent(m_hEvent))? true : false;
}
const bool CSmartEvent::ResetEvent(void)
{
	// CxgZbg
	return (::ResetEvent(m_hEvent))? true : false;
}

const DWORD CSmartEvent::WaitEvent(const DWORD dwTimeout)
{
	// Cxg҂
	switch(::WaitForSingleObject(m_hEvent, (dwTimeout)? dwTimeout : INFINITE)){
		case WAIT_ABANDONED :	return WE_CLOSED;
		case WAIT_OBJECT_0	:	return WE_TRIGGER;
		case WAIT_TIMEOUT	:	return WE_TIMEOUT;
		default				:	return WE_CLOSED;
		}
}


/////////////////////////////////////////////////////////////////////////////
// ~[ebNXbp[NX
/////////////////////////////////////////////////////////////////////////////

CSmartMutex::CSmartMutex(void)
	: m_hMutex(NULL)
{

}

CSmartMutex::~CSmartMutex(void)
{
	Close();
}

const bool CSmartMutex::Create(LPCTSTR lpszName)
{
	// ɂ͔Ή(vZXԂ̔r̂)
	if(!lpszName)return false;
	if(!::lstrlen(lpszName))return false;

	// ɃI[vς݂̏ꍇ̓G[
	if(m_hMutex)return false;
	
	// Mutex쐬
	if(!(m_hMutex = ::CreateMutex(NULL, TRUE, lpszName)))return false;
	
	// ̃vZXŃI[vĂꍇ̓G[
	if(::GetLastError() == ERROR_ALREADY_EXISTS){
		Close();
		return false;
		}
	
	return true;
}

const bool CSmartMutex::Close(void)
{
	if(!m_hMutex)return false;
	
	// Mutex
	const BOOL bReturn = ::CloseHandle(m_hMutex);
	m_hMutex = NULL;
	
	return (bReturn)? true : false;
}

const bool CSmartMutex::IsExist(LPCTSTR lpszName)
{
	// w肵OMutexI[v
	HANDLE hMutex = ::OpenMutex(MUTEX_ALL_ACCESS, FALSE, lpszName);
	
	if(hMutex){
		// Mutex݂͑
		::CloseHandle(hMutex);
		return true;
		}
	else{
		// Mutex݂͑Ȃ
		return false;
		}	
}
