// BonModManager.cpp: BonW[}l[WNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include <TChar.h>
#include "BonSDK.h"
#include "BonModManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// IBonModManagerNX
/////////////////////////////////////////////////////////////////////////////

const DWORD CBonModManager::RegisterModule(void)
{
	DWORD dwModuleNum = 0UL;
	DWORD dwFactoryNum;
	MODULEINFO ModuleInfo;

	// t@CpX\z
	TCHAR szPath[_MAX_PATH + 1] = {TEXT('\0')};
	TCHAR szDrive[_MAX_DRIVE + 1] = {TEXT('\0')};
	TCHAR szDir[_MAX_DIR + 1] = {TEXT('\0')};

	::GetModuleFileName(NULL, szPath, sizeof(szPath) - 1UL);
	::_tsplitpath(szPath, szDrive, szDir, NULL, NULL);
	::_tmakepath(szPath, szDrive, szDir, TEXT("bon_*"), TEXT("dll"));	

	// t@CăI[v
	WIN32_FIND_DATA FindData;
	HANDLE hFileFind = ::FindFirstFile(szPath, &FindData);
	if(hFileFind == INVALID_HANDLE_VALUE)return 0UL;

	do{
		// t@C̒`FbN
		if(::lstrlen(FindData.cFileName) < 9)continue;
	
		// I[vÕt@Ng[ޔ
		dwFactoryNum = ::BonGetFactoryNum();

		// DLLJ
		if(!(ModuleInfo.hModule = ::LoadLibrary(FindData.cFileName)))continue;
		
		// o^ꂽt@Ng[mF
		if(dwFactoryNum == ::BonGetFactoryNum()){
			// 1o^Ȃ̂ŊJ
			::FreeLibrary(ModuleInfo.hModule);
			continue;
			}
	
		// Xgɒǉ
		ModuleInfo.strName = &FindData.cFileName[4];
		m_ModuleList.push_back(ModuleInfo);
		dwModuleNum++;
		}
	while(::FindNextFile(hFileFind, &FindData));

	// I
	::FindClose(hFileFind);

	return dwModuleNum;
}

const DWORD CBonModManager::GetModuleNum(void) const
{
	// W[Ԃ
	return m_ModuleList.size();
}

const DWORD CBonModManager::GetModuleName(const DWORD dwIndex, LPTSTR lpszName) const
{
	if(dwIndex >= GetModuleNum())return 0UL;

	// W[Ԃ
	const DWORD dwNameLen = m_ModuleList[dwIndex].strName.length();
	
	if(lpszName && dwNameLen){
		::lstrcpy(lpszName, m_ModuleList[dwIndex].strName.c_str());
		}
		
	return dwNameLen;
}

CBonModManager::CBonModManager(IBonObject * const pOwner)
	: CBonObject(pOwner)
{

}

CBonModManager::~CBonModManager(void)
{
	// W[J
	for(DWORD dwIndex = 0UL ; dwIndex < m_ModuleList.size() ; dwIndex++){
		::FreeLibrary(m_ModuleList[dwIndex].hModule);
		}
}
