// BonObjectFactory.h: BonIuWFNgt@Ng[̃C^tF[X
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Map>
#include <String>


/////////////////////////////////////////////////////////////////////////////
// BonIuWFNgt@Ng[NX
/////////////////////////////////////////////////////////////////////////////

class CBonObjectFactory
{
public:
	CBonObjectFactory(const HINSTANCE hInstance);
	virtual ~CBonObjectFactory(void);

	const bool RegisterFactory(LPCTSTR lpszBCId, CLASSFACTORYMETHOD const pfnFactoryMethod);
	const bool QueryFactory(LPCTSTR lpszBCId) const;
	IBonObject * CreateInstance(LPCTSTR lpszBCId, IBonObject * const pOwner);
	const DWORD GetFactoryNum(void) const;

	LPCTSTR GuidToClassName(const BONGUID BCId);
	static const BONGUID ClassNameToGuid(LPCTSTR lpszBCId);

protected:
	static const DWORD CalcCrc(const BYTE *pData, const WORD wDataSize, DWORD dwCurCrc = 0xFFFFFFFFUL);

	struct TAG_FACTORYINFO
	{
		CLASSFACTORYMETHOD pfnFactoryMethod;	// NXt@Ng[\bh
		std::wstring strClassName;				// NX
	};
	
	typedef std::map<const BONGUID, TAG_FACTORYINFO> FactoryMap;

	const HINSTANCE m_hInstance;
	FactoryMap m_FactoryMap;
};
