// DllMain.cpp: DLLGg[|Cg̒`
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "MediaBase.h"
#include "BonObjectFactory.h"
#include "BonModManager.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif


/////////////////////////////////////////////////////////////////////////////
// t@C[Jϐ
/////////////////////////////////////////////////////////////////////////////

static CBonObjectFactory *pBonObjectFactory = NULL;
static IBonModManager *pIBonModManager = NULL;


/////////////////////////////////////////////////////////////////////////////
// t@C[J֐vg^Cv
/////////////////////////////////////////////////////////////////////////////

static void CoreLibraryStartup(HMODULE hModule);
static void CoreLibraryShutdown(void);
static void RegisterClassFactory(void);


/////////////////////////////////////////////////////////////////////////////
// DLLGg[
/////////////////////////////////////////////////////////////////////////////

BOOL APIENTRY DllMain(HMODULE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
	switch(ul_reason_for_call){
		case DLL_PROCESS_ATTACH :

#ifdef _DEBUG
			// [NoL
			::_CrtSetDbgFlag(_CRTDBG_LEAK_CHECK_DF | ::_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG)); 
#endif
			// RACu
			::CoreLibraryStartup(hModule);

			break;

		case DLL_PROCESS_DETACH :

			// RACuI
			::CoreLibraryShutdown();

			break;
		}

	return TRUE;
}

static void CoreLibraryStartup(HMODULE hModule)
{
	// t@Ng[CX^X
	pBonObjectFactory = new CBonObjectFactory(hModule);

	// NXt@Ng[o^
	::RegisterClassFactory();

	// W[}l[WCX^X
	pIBonModManager = ::BON_SAFE_CREATE<IBonModManager *>(TEXT("CBonModManager"));

	// W[[h
	pIBonModManager->RegisterModule();
}

static void CoreLibraryShutdown(void)
{
	// W[}l[WCX^XJ
	BON_SAFE_RELEASE(pIBonModManager);

	// t@Ng[CX^XJ
	BON_SAFE_DELETE(pBonObjectFactory);
}

static void RegisterClassFactory(void)
{
	// NXt@Ng[o^(Wgݍ݃NX)
	::BON_REGISTER_CLASS<CBonModManager>();
	::BON_REGISTER_CLASS<CMediaData>();
}


/////////////////////////////////////////////////////////////////////////////
// GNX|[gAPI
/////////////////////////////////////////////////////////////////////////////

BONAPI const bool BonRegisterFactory(LPCTSTR lpszBCId, CLASSFACTORYMETHOD const pfnFactoryMethod)
{
	return pBonObjectFactory->RegisterFactory(lpszBCId, pfnFactoryMethod);
}

BONAPI const bool BonQueryFactory(LPCTSTR lpszBCId)
{
	return pBonObjectFactory->QueryFactory(lpszBCId);
}

BONAPI IBonObject * BonCreateInstance(LPCTSTR lpszBCId, IBonObject * const pOwner)
{
	return pBonObjectFactory->CreateInstance(lpszBCId, pOwner);
}

BONAPI const DWORD BonGetFactoryNum(void)
{
	return pBonObjectFactory->GetFactoryNum();
}

BONAPI LPCTSTR BonGuidToClassName(const BONGUID BCId)
{
	return pBonObjectFactory->GuidToClassName(BCId);
}

BONAPI const BONGUID BonClassNameToGuid(LPCTSTR lpszBCId)
{
	return CBonObjectFactory::ClassNameToGuid(lpszBCId);
}

BONAPI const IBonModManager * GetModManager(void)
{
	return pIBonModManager;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif
