// MediaDecoderIf.h: fBAfR[_C^tF[X`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// TS\[X`[ifR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class ITsSourceTuner :			public IBonObject
{
public:
	enum	// OpenTuner() G[R[h
	{
		EC_OPEN_SUCCESS	= 0x00000000UL,		// I[v
		EC_DEVICE_NONE	= 0x00000001UL,		// `[iȂ
		EC_DEVICE_FULL	= 0x00000002UL,		// gp\ȃ`[iȂ
		EC_OPEN_FAILED	= 0x00000003UL,		// I[vs
		EC_INTERNAL_ERR	= 0x00000004UL		// G[
	};
	
	virtual const DWORD OpenTuner(LPCTSTR lpszBCId) = 0;
	virtual const bool CloseTuner(void) = 0;

	virtual const DWORD GetDeviceName(LPTSTR lpszName) = 0;

	virtual const DWORD GetTuningSpaceName(const DWORD dwSpace, LPTSTR lpszName) = 0;
	virtual const DWORD GetChannelName(const DWORD dwSpace, const DWORD dwChannel, LPTSTR lpszName) = 0;
	
	virtual const DWORD GetCurSpace(void) = 0;
	virtual const DWORD GetCurChannel(void) = 0;

	virtual const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel) = 0;
	virtual const float GetSignalLevel(void) = 0;
	
	virtual IHalTsTuner * GetHalTsTuner(void) = 0;
};


/////////////////////////////////////////////////////////////////////////////
// TSpPbgfR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class ITsPacketSync :			public IBonObject
{
public:
	enum	// fR[_CxgID				// [Cxge]				[pParam]
	{
		EID_SYNC_ERR		= 0x00000000UL,		// G[o				(DWORD)G[
		EID_FORMAT_ERR		= 0x00000001UL,		// tH[}bgG[o		(DWORD)G[
		EID_TRANSPORT_ERR	= 0x00000002UL,		// gX|[gG[o		(DWORD)G[
		EID_CONTINUITY_ERR	= 0x00000003UL		// A(hbv)G[o	(DWORD)G[
	};

	virtual void DiscardNullPacket(const bool bEnable = true) = 0;

	virtual void ResetStatistics(void) = 0;

	virtual const DWORD GetPacketStride(void) const = 0;

	virtual const DWORD GetInputPacketNum(void) const = 0;
	virtual const DWORD GetOutputPacketNum(void) const = 0;

	virtual const DWORD GetInputBitrate(void) const = 0;
	virtual const DWORD GetOutputBitrate(void) const = 0;

	virtual const DWORD GetSyncErrNum(void) const = 0;
	virtual const DWORD GetFormatErrNum(void) const = 0;
	virtual const DWORD GetTransportErrNum(void) const = 0;
	virtual const DWORD GetContinuityErrNum(void) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// TSfXNufR[_C^tF[X
/////////////////////////////////////////////////////////////////////////////

class ITsDescrambler :			public IBonObject
{
public:
	enum	// fR[_CxgID				// [Cxge]				[pParam]
	{
		EID_CANT_DESCRAMBLE	= 0x00000000UL,		// RpPbgo			(DWORD)RpPbg
		EID_ECM_PROCESSED	= 0x00000001UL,		// ECM					(DWORD)GetDescramblerState() ^[R[h
		EID_EMM_PROCESSED	= 0x00000002UL		// EMM					(bool)EMM
	};

	enum	// GetDescramblerState() ^[R[h
	{
		DS_NO_ERROR			= 0x00000000UL,		// G[Ȃ
		DS_BCAS_ERROR		= 0x00000001UL,		// B-CASJ[hG[
		DS_NOT_CONTRACTED	= 0x00000002UL		// _
	};

	virtual const bool OpenDescrambler(LPCTSTR lpszBCId) = 0;
	virtual const bool CloseDescrambler(void) = 0;

	virtual void DiscardScramblePacket(const bool bEnable = true) = 0;
	virtual void EnableEmmProcess(const bool bEnable = true) = 0;

	virtual void ResetStatistics(void) = 0;

	virtual const DWORD GetDescramblingState(const WORD wProgramID) const = 0;

	virtual const DWORD GetInputPacketNum(void) const = 0;
	virtual const DWORD GetOutputPacketNum(void) const = 0;
	virtual const DWORD GetScramblePacketNum(void) const = 0;
	virtual const DWORD GetEcmProcessNum(void) const = 0;
	virtual const DWORD GetEmmProcessNum(void) const = 0;
	
	virtual IHalBcasCard * GetHalBcasCard(void) = 0;
};
