// TsTableIf.h: TSe[uC^tF[X`
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


/////////////////////////////////////////////////////////////////////////////
// [0x00] PATe[uC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IPatTable :	public IBonObject
{
public:
	// PATe[unhC^tF[X
	class IHandler :	public IBonObject
	{
	public:
		virtual void OnPatTable(const IPatTable *pPatTable) = 0;
	};

	enum {TABLE_ID = 0x00U};

	virtual const WORD GetTsID(void) const = 0;

	virtual const WORD GetNitPID(const WORD wIndex = 0U) const = 0;
	virtual const WORD GetNitNum(void) const = 0;

	virtual const WORD GetPmtPID(const WORD wIndex = 0U) const = 0;
	virtual const WORD GetProgramID(const WORD wIndex = 0U) const = 0;
	virtual const WORD GetProgramNum(void) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// [0x01] CATe[uC^tF[X
/////////////////////////////////////////////////////////////////////////////

class ICatTable :	public IBonObject
{
public:
	// CATe[unhC^tF[X
	class IHandler :	public IBonObject
	{
	public:
		virtual void OnCatTable(const ICatTable *pCatTable) = 0;
	};

	enum {TABLE_ID = 0x01U};

	virtual const IDescBlock * GetCatDesc(void) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// [0x02] PMTe[uC^tF[X
/////////////////////////////////////////////////////////////////////////////

class IPmtTable :	public IBonObject
{
public:
	// PMTe[unhC^tF[X
	class IHandler :	public IBonObject
	{
	public:
		virtual void OnPmtTable(const IPmtTable *pPmtTable) = 0;
	};

	enum {TABLE_ID = 0x02U};

	virtual const WORD GetProgramID(void) const = 0;
	virtual const WORD GetPcrPID(void) const = 0;
	virtual const IDescBlock * GetPmtDesc(void) const = 0;

	virtual const WORD GetEsNum(void) const = 0;
	virtual const BYTE GetStreamTypeID(const WORD wIndex) const = 0;
	virtual const WORD GetEsPID(const WORD wIndex) const = 0;
	virtual const IDescBlock * GetEsDesc(const WORD wIndex) const = 0;
};


/////////////////////////////////////////////////////////////////////////////
// [0x73] TOTe[uC^tF[X
/////////////////////////////////////////////////////////////////////////////

class ITotTable :	public IBonObject
{
public:
	// TOTe[unhC^tF[X
	class IHandler :	public IBonObject
	{
	public:
		virtual void OnTotTable(const ITotTable *pTotTable) = 0;
	};

	enum {TABLE_ID = 0x73U};

	virtual const SYSTEMTIME & GetDateTime(void) const = 0;
	virtual const IDescBlock * GetTotDesc(void) const = 0;
};
