// BonBlackTuner.cpp: Friio`[i[NX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "Resource.h"
#include "BonSDK.h"
#include "BonBlackTuner.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// foCX
#define DEVICENAME	TEXT(" Friio USB 2.0 Digital TV Receiver")

// obt@ݒ
#define ASYNCBUFFTIME		2UL											// obt@ = 2b
#define ASYNCBUFFNUM		(0x400000UL / TSRECVSIZE * ASYNCBUFFTIME)	// 32MbpsƂ

#define REQRESERVNUM		16UL			// 񓯊NGXg\
#define REQPOLLINGWAIT		10UL			// 񓯊NGXg|[OԊu(ms)

// I/ORg[R[h
#define IOCODE_CONTROL		0x00220020UL	// `[iRg[
#define IOCODE_STREAM		0x0022004BUL	// Xg[NGXg


/////////////////////////////////////////////////////////////////////////////
// Friiop@TS`[i HALC^tF[XNX
/////////////////////////////////////////////////////////////////////////////

HINSTANCE CBonBlackTuner::m_hModule = NULL;

const BONGUID CBonBlackTuner::GetDeviceType(void)
{
	// foCX̃^CvԂ
	return ::BonClassNameToGuid(TEXT("IHalTsTuner"));
}

const DWORD CBonBlackTuner::GetDeviceName(LPTSTR lpszName)
{
	// foCXԂ
	if(lpszName)::lstrcpy(lpszName, DEVICENAME);

	return ::lstrlen(DEVICENAME);
}

const DWORD CBonBlackTuner::GetTotalDeviceNum(void)
{
	// FriiȏԂ
	return (m_BonEnumerator.EnumDevice(true))? m_BonEnumerator.GetTotalNum() : 0UL;
}

const DWORD CBonBlackTuner::GetActiveDeviceNum(void)
{
	// gp̍Friio̐Ԃ
	return (m_BonEnumerator.EnumDevice(true))? m_BonEnumerator.GetActiveNum() : 0UL;
}

const bool CBonBlackTuner::OpenTuner(void)
{
	CloseTuner();
	
	try{
		// hCo
		if(!m_BonEnumerator.EnumDevice(true))throw;
	
		// gp̃`[i擾
		LPCTSTR lpszDriverPath = m_BonEnumerator.GetAvailableDriverPath();
		if(!lpszDriverPath)throw;

		// hCoI[v
		if((m_hFriioDriver = ::CreateFile(lpszDriverPath, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL)) == INVALID_HANDLE_VALUE)throw;

		// hCobN
		if(!m_BonEnumerator.LockDevice(lpszDriverPath))throw;
		
		// V[PXM
		if(!SendFixedRequest(IDR_INISEQ_BLACK))throw;
		
		// ftHg`lݒ
		if(!SetChannel(0UL, 0UL))throw;
		
		// CxgZbg
		if(!m_TsRecvEvent.ResetEvent())throw;
		
		// obt@m
		if(!AllocateBuffer(ASYNCBUFFNUM + REQRESERVNUM))throw;
		
		// XbhN
		if(!m_IoReqThread.StartThread(this, &CBonBlackTuner::IoReqThread))throw;
		if(!m_IoRecvThread.StartThread(this, &CBonBlackTuner::IoRecvThread))throw;
		}
	catch(...){
		// G[
		CloseTuner();
		return false;
		}
	
	return true;
}

void CBonBlackTuner::CloseTuner(void)
{
	// Xbh~
	m_IoReqThread.EndThread();
	m_IoRecvThread.EndThread();

	// CxgZbg(ҋ@XbhJ)
	m_TsRecvEvent.SetEvent();

	// obt@J
	ReleaseBuffer();
	
	if(m_hFriioDriver != INVALID_HANDLE_VALUE){
		// IV[PXM
		SendFixedRequest(IDR_ENDSEQ_BLACK);

		// hCoN[Y
		::CloseHandle(m_hFriioDriver);
		m_hFriioDriver = INVALID_HANDLE_VALUE;
		}

	// hCobNJ
	m_BonEnumerator.ReleaseDevice();
	
	// `l
	m_dwCurSpace = 0UL;
	m_dwCurChannel = 0UL;
}

LPCTSTR CBonBlackTuner::EnumTuningSpace(const DWORD dwSpace)
{
	// gp\ȃ`[jOԂԂ
	switch(dwSpace){
		case 0UL :	return TEXT("BS");
		case 1UL :	return TEXT("110CS");
		default  :	return NULL;		
		}
}

LPCTSTR CBonBlackTuner::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	// gp\ȃ`lԂ
	switch(dwSpace){
		case 0UL :
			// BS
			switch(dwChannel){
				case 0UL :	return TEXT("BS1/TS0 BS"		 );
				case 1UL :	return TEXT("BS1/TS1 BS-i"			 );
				case 2UL :	return TEXT("BS3/TS0 WOWOW"			 );
				case 3UL :	return TEXT("BS3/TS1 BSWp"	 );
				case 4UL :	return TEXT("BS9/TS0 BS11"			 );
				case 5UL :	return TEXT("BS9/TS1 Star Channel HV");
				case 6UL :	return TEXT("BS9/TS2 TwellV"		 );
				case 7UL :	return TEXT("BS13/TS0 BSe"		 );
				case 8UL :	return TEXT("BS13/TS1 BStW"		 );
				case 9UL :	return TEXT("BS15/TS1 NHK BS1/2"	 );
				case 10UL :	return TEXT("BS15/TS2 NHK BS-hi"	 );
				}
	
			return NULL;
		
		case 1UL :
			// 110CS
			switch(dwChannel){
				case 0UL :	return TEXT("ND2 110CS #1"  );
				case 1UL :	return TEXT("ND4 110CS #2"  );
				case 2UL :	return TEXT("ND6 110CS #3"  );
				case 3UL :	return TEXT("ND8 110CS #4"  );
				case 4UL :	return TEXT("ND10 110CS #5" );
				case 5UL :	return TEXT("ND12 110CS #6" );
				case 6UL :	return TEXT("ND14 110CS #7" );
				case 7UL :	return TEXT("ND16 110CS #8" );
				case 8UL :	return TEXT("ND18 110CS #9" );
				case 9UL :	return TEXT("ND20 110CS #10");
				case 10UL :	return TEXT("ND22 110CS #11");
				case 11UL :	return TEXT("ND24 110CS #12");
				}
		
			return NULL;
		
		default  :
			// Ή̃`[jO
			return NULL;
		}
}

const DWORD CBonBlackTuner::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_dwCurSpace;
}

const DWORD CBonBlackTuner::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_dwCurChannel;
}

const bool CBonBlackTuner::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// `[jOV[PXϕ
	static const BYTE abyPllConfA[] = {0x08U, 0x08U, 0x08U, 0x08U, 0x09U, 0x09U, 0x09U, 0x0AU, 0x0AU, 0x0AU, 0x0AU, 0x0CU, 0x0CU, 0x0DU, 0x0DU, 0x0DU, 0x0EU, 0x0EU, 0x0EU, 0x0FU, 0x0FU, 0x0FU, 0x10U};	// 1/17 +40
	static const BYTE abyPllConfB[] = {0x32U, 0x32U, 0x80U, 0x80U, 0x64U, 0x64U, 0x64U, 0x00U, 0x00U, 0x4CU, 0x4CU, 0x9AU, 0xEAU, 0x3AU, 0x8AU, 0xDAU, 0x2AU, 0x7AU, 0xCAU, 0x1AU, 0x6AU, 0xBAU, 0x0AU};	// 2/18 +40
	static const BYTE abyPllConfC[] = {0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x40U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};	// 75	+02
	static const BYTE abyPllConfD[] = {0x10U, 0x11U, 0x30U, 0x31U, 0x90U, 0x91U, 0x92U, 0xD0U, 0xD1U, 0xF1U, 0xF2U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U, 0x00U};	// 76	+02

	// `[jO͈̓`FbN
	if(!EnumChannelName(dwSpace, dwChannel))return false;

	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(IDR_CHSEQ_BLACK), TEXT("BINARY"));
	if(!hRsrc)return false;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return false;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return false;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	const DWORD dwChIndex = dwSpace * 11UL + dwChannel;
	DWORD dwXmitNum = 0UL;
	DWORD dwXmited = 0UL;
	FIXED_REQ_HEAD *pFixedReqHead;

	while(dwXmited < dwIoReqSize){
		// Rg[擾
		pFixedReqHead = (FIXED_REQ_HEAD *)pFixedBuff;
		pFixedBuff += sizeof(FIXED_REQ_HEAD);

		// Mf[^
		::CopyMemory(m_RxdBuff, pFixedBuff, pFixedReqHead->wTxdSize);

		switch(dwXmitNum++){
			case 0UL  :	m_RxdBuff[40] = abyPllConfA[dwChIndex];	break;
			case 1UL  :	m_RxdBuff[40] = abyPllConfB[dwChIndex];	break;
			case 16UL :	m_RxdBuff[40] = abyPllConfA[dwChIndex];	break;
			case 17UL :	m_RxdBuff[40] = abyPllConfB[dwChIndex];	break;
			case 74UL :	m_RxdBuff[ 2] = abyPllConfC[dwChIndex];	break;
			case 75UL :	m_RxdBuff[ 2] = abyPllConfD[dwChIndex];	break;
			}

		// f[^M
		if(SendIoRequest(pFixedReqHead->dwIoCode, m_RxdBuff, pFixedReqHead->wTxdSize, m_RxdBuff, pFixedReqHead->wRxdSize) == -1)return false;
		pFixedBuff += pFixedReqHead->wTxdSize;
		
		// MσTCYXV
		dwXmited += (sizeof(FIXED_REQ_HEAD) + pFixedReqHead->wTxdSize);
		}

	// `lXV
	m_dwCurSpace = dwSpace;
	m_dwCurChannel = dwChannel;

	// Xg[p[W
	PurgeStream();

	return true;
}

const float CBonBlackTuner::GetSignalLevel(void)
{
	// Mxv
	static const BYTE abyGetLevReq[] = {0xC0, 0x02 ,0x00, 0x32, 0xBA, 0x00, 0x04, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x26, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	// `⊮ŋߎ
	static const float afLevelTable[] =
	{
		24.07f,	// 00	00	0		24.07dB
		24.07f,	// 10	00	4096	24.07dB
		18.61f,	// 20	00	8192	18.61dB
		15.21f,	// 30	00	12288	15.21dB
		12.50f,	// 40	00	16384	12.50dB
		10.19f,	// 50	00	20480	10.19dB
		8.140f,	// 60	00	24576	8.140dB
		6.270f,	// 70	00	28672	6.270dB
		4.550f,	// 80	00	32768	4.550dB
		3.730f,	// 88	00	34816	3.730dB
		3.630f,	// 88	FF	35071	3.630dB
		2.940f,	// 90	00	36864	2.940dB
		1.420f,	// A0	00	40960	1.420dB
		0.000f	// B0	00	45056	-0.01dB
	};

	// Mobt@NA
	::ZeroMemory(m_RxdBuff, sizeof(abyGetLevReq));

	// Mxv
	if(SendIoRequest(IOCODE_CONTROL, (BYTE *)abyGetLevReq, sizeof(abyGetLevReq), m_RxdBuff, sizeof(abyGetLevReq)) == -1)return 0.0f;

	// MxvZ
	if(m_RxdBuff[40] <= 0x10U){
		// őNbv
		return 24.07f;
		}
	else if(m_RxdBuff[40] >= 0xB0U){
		// ŏNbv
		return 0.0f;
		}
	else{
		// `⊮
		const float fMixRate = (float)(((WORD)(m_RxdBuff[40] & 0x0FU) << 8) | (WORD)m_RxdBuff[41]) / 4095.0f;
		return afLevelTable[m_RxdBuff[40] >> 4] * (1.0f - fMixRate) + afLevelTable[(m_RxdBuff[40] >> 4) + 0x01U] * fMixRate;
		}
}

const bool CBonBlackTuner::GetStream(BYTE **ppStream, DWORD *pdwSize, DWORD *pdwRemain)
{
	CBlockLock AutoLock(&m_AsyncReqLock);

	// ML[珈σf[^o
	if(m_hFriioDriver == INVALID_HANDLE_VALUE){
		// `[iI[vĂȂ
		return false;
		}
	else if(m_AsyncRecvQue.empty()){
		// o\ȃf[^Ȃ
		if(ppStream)*ppStream = NULL;
		if(pdwSize)*pdwSize = 0UL;
		if(pdwRemain)*pdwRemain = 0UL;
		}
	else{	
		// f[^o
		if(ppStream)*ppStream = m_AsyncRecvQue.front()->RxdBuff;
		if(pdwSize)*pdwSize = m_AsyncRecvQue.front()->dwRxdSize;

		m_AsyncRecvQue.pop();
		
		if(pdwRemain)*pdwRemain = m_AsyncRecvQue.size();
		}

	return true;
}

void CBonBlackTuner::PurgeStream(void)
{
	CBlockLock AutoLock(&m_AsyncReqLock);

	// ML[NA
	while(!m_AsyncRecvQue.empty())m_AsyncRecvQue.pop();
}

const DWORD CBonBlackTuner::WaitStream(const DWORD dwTimeOut)
{
	// Xg[EFCg
	return m_TsRecvEvent.WaitEvent(dwTimeOut);
}

const DWORD CBonBlackTuner::GetAvailableNum(void)
{
	// o\Xg[Ԃ
	return m_AsyncRecvQue.size();
}

CBonBlackTuner::CBonBlackTuner(IBonObject * const pOwner)
	: CBonObject(pOwner)
	, m_hFriioDriver(NULL)
	, m_dwCurSpace(0UL)
	, m_dwCurChannel(0UL)
{

}

CBonBlackTuner::~CBonBlackTuner(void)
{
	CloseTuner();
}

void CBonBlackTuner::SetModuleHandle(const HINSTANCE hModule)
{
	// W[nho^
	m_hModule = hModule;
}

const int CBonBlackTuner::SendIoRequest(const DWORD dwIoCode, const BYTE *pTxdData, const DWORD dwTxdSize, BYTE *pRxdData, const DWORD dwRxdSize)
{
	// I[v`FbN
	if(m_hFriioDriver == INVALID_HANDLE_VALUE)return -1;

	// Mpf[^ݒ
	OVERLAPPED OverLapped;
	::ZeroMemory(&OverLapped, sizeof(OverLapped));
	if(!(OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return -1;

	// Mf[^Rs[
	::CopyMemory(m_TxdBuff, pTxdData, dwTxdSize);

	// f[^M
	DWORD dwReturned = 0UL;
	const BOOL bReturn = ::DeviceIoControl(m_hFriioDriver, dwIoCode, m_TxdBuff, dwTxdSize, pRxdData, dwRxdSize, &dwReturned, &OverLapped);
	
	// Cxg폜
	::CloseHandle(OverLapped.hEvent);

	// G[AMf[^擾
	if(!bReturn){
		if(::GetLastError() != ERROR_IO_PENDING)return -1;
		if(!::GetOverlappedResult(m_hFriioDriver, &OverLapped, &dwReturned, TRUE))return -1;
		}

	return (int)dwReturned;
}

const bool CBonBlackTuner::SendFixedRequest(const UINT nID)
{
	// \[Xnh擾
	HRSRC hRsrc = ::FindResource(m_hModule, MAKEINTRESOURCE(nID), TEXT("BINARY"));
	if(!hRsrc)return false;

	// \[X[h
	HGLOBAL hGlobal = ::LoadResource(m_hModule, hRsrc);
	if(!hGlobal)return false;

	// |C^擾
	BYTE *pFixedBuff = (BYTE *)::LockResource(hGlobal);
	if(!pFixedBuff)return false;

	// \[XTCY擾
	const DWORD dwIoReqSize = ::SizeofResource(m_hModule, hRsrc);

	// \[Xf[^𑗐M
	DWORD dwXmited = 0UL;
	FIXED_REQ_HEAD *pFixedReqHead;

	while(dwXmited < dwIoReqSize){
		// Rg[擾
		pFixedReqHead = (FIXED_REQ_HEAD *)pFixedBuff;
		pFixedBuff += sizeof(FIXED_REQ_HEAD);

		// f[^M
		if(SendIoRequest(pFixedReqHead->dwIoCode, pFixedBuff, pFixedReqHead->wTxdSize, m_RxdBuff, pFixedReqHead->wRxdSize) == -1)return false;
		pFixedBuff += pFixedReqHead->wTxdSize;
		
		// MσTCYXV
		dwXmited += (sizeof(FIXED_REQ_HEAD) + pFixedReqHead->wTxdSize);
		}

	return true;
}

const bool CBonBlackTuner::AllocateBuffer(const DWORD dwBufferNum)
{
	// obt@mۂ
	m_AsyncReqPool.resize(dwBufferNum);
	if(m_AsyncReqPool.size() < dwBufferNum)return false;

	// obt@v[ʒu
	m_itAsyncReq = m_AsyncReqPool.begin();

	return true;
}

void CBonBlackTuner::ReleaseBuffer(void)
{
	// NGXgL[J
	while(!m_AsyncReqQue.empty())m_AsyncReqQue.pop();

	// ML[J
	while(!m_AsyncRecvQue.empty())m_AsyncRecvQue.pop();

	// obt@J
	m_AsyncReqPool.clear();
}

void CBonBlackTuner::IoReqThread(CSmartThread<CBonBlackTuner> *pThread, bool &bKillSignal, PVOID pParam)
{
	// hCoɃXg[NGXg𔭍s
	while(!bKillSignal){
		// NGXg҂K薢Ȃǉ
		if(m_AsyncReqQue.size() < REQRESERVNUM){

			// hCoTSf[^NGXg𔭍s
			if(!PushIoRequest())break;

			continue;
			}

		// NGXg҂t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}
}

void CBonBlackTuner::IoRecvThread(CSmartThread<CBonBlackTuner> *pThread, bool &bKillSignal, PVOID pParam)
{
	// σNGXg|[OăNGXg
	while(!bKillSignal){
		// σf[^΃NGXg
		if(m_AsyncReqQue.size() && (m_AsyncRecvQue.size() < ASYNCBUFFNUM)){

			// NGXg
			if(!PopIoRequest())break;

			continue;
			}

		// σL[t̏ꍇ̓EFCg
		::Sleep(REQPOLLINGWAIT);
		}
}

const bool CBonBlackTuner::PushIoRequest(void)
{
	// Xg[NGXg
	static const BYTE abyStreamReq[]  = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

	// NGXgL[ɃNGXgǉ
	if(m_hFriioDriver == INVALID_HANDLE_VALUE)return false;

	// NGXgݒ
	m_itAsyncReq->dwRxdSize = 0UL;
	::CopyMemory(m_itAsyncReq->TxdBuff, abyStreamReq, sizeof(abyStreamReq));
	::ZeroMemory(&m_itAsyncReq->OverLapped, sizeof(OVERLAPPED));
	if(!(m_itAsyncReq->OverLapped.hEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL)))return false;
	
	// NGXgs
	if(!::DeviceIoControl(m_hFriioDriver, IOCODE_STREAM, m_itAsyncReq->TxdBuff, sizeof(abyStreamReq), m_itAsyncReq->RxdBuff, TSRECVSIZE, &m_itAsyncReq->dwRxdSize, &m_itAsyncReq->OverLapped)){
		if(::GetLastError() != ERROR_IO_PENDING){
			::CloseHandle(m_itAsyncReq->OverLapped.hEvent);
			return false;
			}
		}

	// L[ɓ
	m_AsyncReqLock.Lock();
	m_AsyncReqQue.push(&(*m_itAsyncReq));
	if(++m_itAsyncReq == m_AsyncReqPool.end())m_itAsyncReq = m_AsyncReqPool.begin();
	m_AsyncReqLock.Unlock();
	
	return true;
}

const bool CBonBlackTuner::PopIoRequest(void)
{
	// NGXgL[珈σf[^oAML[ɒǉ
	if(m_hFriioDriver == INVALID_HANDLE_VALUE)return false;

	// NGXgʎ擾
	m_AsyncReqLock.Lock();
	ASYNC_REQ_DATA *pFrontReq = m_AsyncReqQue.front();
	m_AsyncReqLock.Unlock();
	
	if(!::GetOverlappedResult(m_hFriioDriver, &pFrontReq->OverLapped, &pFrontReq->dwRxdSize, FALSE)){
		if(::GetLastError() == ERROR_IO_INCOMPLETE){
			// AEFCg
			::Sleep(REQPOLLINGWAIT);
			return true;
			}
		else{
			// G[
			::CloseHandle(pFrontReq->OverLapped.hEvent);		
			return false;
			}
		}

	// CxgJ
	::CloseHandle(pFrontReq->OverLapped.hEvent);

	// L[oAǉ
	m_AsyncReqLock.Lock();
	m_AsyncReqQue.pop();
	m_AsyncRecvQue.push(pFrontReq);
	m_AsyncReqLock.Unlock();

	// CxgZbg
	m_TsRecvEvent.SetEvent();

	return true;
}
