// TsDescrambler.cpp: TSfXNufR[_
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsDescrambler.h"
#include "TsTable.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

// EMML
#define EMM_VALID_PERIOD			7UL			// 7day

// B-CASJ[hďK[hC^[o
#define BCAS_REFRESH_INTERVAL		1000UL		// 1s

// NbvtCNg}N
#define CLIPED_INCREMENT(V)			{if((V) < 0xFFFFFFFFUL)(V)++;}


/////////////////////////////////////////////////////////////////////////////
// TSfXNufR[_
/////////////////////////////////////////////////////////////////////////////

const bool CTsDescrambler::InputMedia(IMediaData *pMediaData, const DWORD dwInputIndex)
{
	// ̓p[^`FbN
	ITsPacket * const pTspacket = dynamic_cast<ITsPacket *>(pMediaData);
	if(!pTspacket || (dwInputIndex > GetInputNum()))return false;

	// PID}bvɓ
	if(m_pHalBcasCard)m_TsPidMapper.StorePacket(pTspacket);

	// ̓pPbgCNg
	CLIPED_INCREMENT(m_dwInputPacketNum);

	if(pTspacket->IsScrambled()){
		// RpPbgCNg
		CLIPED_INCREMENT(m_dwScramblePacketNum);
		SendDecoderEvent(EID_CANT_DESCRAMBLE, reinterpret_cast<PVOID>(m_dwScramblePacketNum));
		
		// RpPbgjL͉ʃfR[_ɏo͂Ȃ
		if(m_bDiscardScramblePacket)return true;
		}
	
	// o̓pPbgCNg
	CLIPED_INCREMENT(m_dwOutputPacketNum);
	
	// ʃfR[_Ƀf[^o
	OutputMedia(pMediaData);

	return true;
}

const bool CTsDescrambler::OpenDescrambler(LPCTSTR lpszBCId)
{
	// UN[Y
	CloseDescrambler();

	IHalDevice *pHalDevice = NULL;

	try{
		// B-CASJ[h̃CX^X𐶐
		if(!(pHalDevice = ::BON_SAFE_CREATE<IHalDevice *>(lpszBCId)))throw 0UL;

		// foCX^Cv`FbN
		if(pHalDevice->GetDeviceType() != ::BonClassNameToGuid(TEXT("IHalBcasCard")))throw 0UL;

		// foCX݂̑`FbN
		if(!pHalDevice->GetTotalDeviceNum())throw 0UL;

		// foCX̋󂫂`FbN
		if(pHalDevice->GetActiveDeviceNum() >= pHalDevice->GetTotalDeviceNum())throw 0UL;
	
		// IHalBcasCardC^tF[X擾
		if(!(m_pHalBcasCard = dynamic_cast<IHalBcasCard *>(pHalDevice)))throw 0UL;

		// B-CASJ[hI[v
		if(!m_pHalBcasCard->OpenCard())throw 0UL;
		}
	catch(...){
		// G[
		BON_SAFE_RELEASE(pHalDevice);
		m_pHalBcasCard = NULL;
		
		CloseDescrambler();
		return false;
		}

	return true;
}

const bool CTsDescrambler::CloseDescrambler(void)
{
	// B-CASJ[hN[Y
	BON_SAFE_RELEASE(m_pHalBcasCard);

	return true;
}

void CTsDescrambler::DiscardScramblePacket(const bool bEnable)
{
	// XNuRpPbgj邩ݒ
	m_bDiscardScramblePacket = (bEnable)? true : false;
}

void CTsDescrambler::EnableEmmProcess(const bool bEnable)
{
	// EMM邩ݒ
	m_bEnableEmmProcess = (bEnable)? true : false;
}

void CTsDescrambler::ResetStatistics(void)
{
	// vf[^Zbg
	m_dwInputPacketNum = 0UL;
	m_dwOutputPacketNum = 0UL;
	m_dwScramblePacketNum = 0UL;
	m_dwEcmProcessNum = 0UL;
	m_dwEmmProcessNum = 0UL;
}

const DWORD CTsDescrambler::GetDescramblingState(const WORD wProgramID) const
{
	// PATe[u擾
	const IPatTable *pPatTable = dynamic_cast<const IPatTable *>(m_TsPidMapper.GetMapTarget(0x0000U));
	if(!pPatTable)return IHalBcasCard::EC_BADARGUMENT;
		
	// ɈvPMTPID
	for(WORD wIndex = 0U ; wIndex < pPatTable->GetProgramNum() ; wIndex++){
		if(pPatTable->GetProgramID(wIndex) == wProgramID){
			
			// PMTe[u擾
			const IPmtTable *pPmtTable = dynamic_cast<const IPmtTable *>(m_TsPidMapper.GetMapTarget(pPatTable->GetPmtPID(wIndex)));
			if(!pPmtTable)return IHalBcasCard::EC_BADARGUMENT;
			
			// ECMPID擾
			const IDescBlock * const pDescBlock = pPmtTable->GetPmtDesc();
			if(!pDescBlock)return IHalBcasCard::EC_BADARGUMENT;
	
			const ICaMethodDesc * const pCaMethodDesc = dynamic_cast<const ICaMethodDesc *>(pDescBlock->GetDescByTag(ICaMethodDesc::DESC_TAG));
			if(!pCaMethodDesc)return IHalBcasCard::EC_BADARGUMENT;

			const WORD wEcmPID = pCaMethodDesc->GetCaPID();
			if(wEcmPID >= TS_INVALID_PID)return IHalBcasCard::EC_NO_ERROR;

			// ECMvZbT擾
			const CEcmProcessor *pEcmProcessor = dynamic_cast<const CEcmProcessor *>(m_TsPidMapper.GetMapTarget(pPatTable->GetPmtPID(wEcmPID)));
			if(!pEcmProcessor)return IHalBcasCard::EC_BADARGUMENT;
			
			// ԂԂ
			return pEcmProcessor->m_dwDescramblingState;	
			}		
		}

	return IHalBcasCard::EC_BADARGUMENT;
}

const DWORD CTsDescrambler::GetInputPacketNum(void) const
{
	// ̓pPbgԂ
	return m_dwInputPacketNum;
}

const DWORD CTsDescrambler::GetOutputPacketNum(void) const
{
	// o̓pPbgԂ
	return m_dwOutputPacketNum;
}

const DWORD CTsDescrambler::GetScramblePacketNum(void) const
{
	// RpPbgԂ
	return m_dwScramblePacketNum;
}

const DWORD CTsDescrambler::GetEcmProcessNum(void) const
{
	// ECM񐔂Ԃ
	return m_dwEcmProcessNum;
}

const DWORD CTsDescrambler::GetEmmProcessNum(void) const
{
	// EMM񐔂Ԃ
	return m_dwEmmProcessNum;
}

IHalBcasCard * CTsDescrambler::GetHalBcasCard(void)
{
	// B-CASJ[h[_foCXԂ
	return m_pHalBcasCard;
}

CTsDescrambler::CTsDescrambler(IBonObject * const pOwner)
	: CMediaDecoder(pOwner, 1UL, 1UL)
	, m_TsPidMapper(NULL)
	, m_pHalBcasCard(NULL)
	, m_bDiscardScramblePacket(false)
	, m_bEnableEmmProcess(false)
	, m_wLastTsID(0x0000U)
	, m_dwInputPacketNum(0UL)
	, m_dwOutputPacketNum(0UL)
	, m_dwScramblePacketNum(0UL)
	, m_dwEcmProcessNum(0UL)
	, m_dwEmmProcessNum(0UL)
{
	// Ȃ
}

CTsDescrambler::~CTsDescrambler(void)
{
	CloseDescrambler();
}

const bool CTsDescrambler::OnPlay(void)
{
	// Ԃ
	return OnReset();
}

const bool CTsDescrambler::OnReset(void)
{
	// TS IDNA
	m_wLastTsID = 0x0000U;

	// PID}bv
	MapFixedTable();

	// vf[^Zbg
	ResetStatistics();

	return true;
}

void CTsDescrambler::OnPatTable(const IPatTable *pPatTable)
{
	// PMTe[uPID}bvǉ
	for(WORD wIndex = 0U ; wIndex < pPatTable->GetProgramNum() ; wIndex++){
		m_TsPidMapper.MapPid(pPatTable->GetPmtPID(wIndex), dynamic_cast<ITsPidMapTarget *>(CPmtTable::CreateInstance(dynamic_cast<IPmtTable::IHandler *>(this))));
		}

	// TS ID̕ω`FbN
	const WORD wNewTsID = pPatTable->GetTsID();

	if(wNewTsID != m_wLastTsID){
		// TS IDωƂ͏ԂZbg(MapFixedTable()Ăт̃ReLXgł͕s\)
		m_TsPidMapper.ResetPid();
		m_wLastTsID = wNewTsID;
		}
}

void CTsDescrambler::OnCatTable(const ICatTable *pCatTable)
{
	// EMMPID擾
	const IDescBlock * const pDescBlock = pCatTable->GetCatDesc();
	if(!pDescBlock)return;
	
	const ICaMethodDesc * const pCaMethodDesc = dynamic_cast<const ICaMethodDesc *>(pDescBlock->GetDescByTag(ICaMethodDesc::DESC_TAG));
	if(!pCaMethodDesc)return;

	const WORD wEmmPID = pCaMethodDesc->GetCaPID();
	if(wEmmPID >= TS_INVALID_PID)return;

	// EMMvZbTPID}bvɒǉ
	m_TsPidMapper.MapPid(wEmmPID, dynamic_cast<ITsPidMapTarget *>(CEmmProcessor::CreateInstance(dynamic_cast<ITsDescrambler *>(this))));
}

void CTsDescrambler::OnPmtTable(const IPmtTable *pPmtTable)
{
	// ECMPID擾
	const IDescBlock * const pDescBlock = pPmtTable->GetPmtDesc();
	if(!pDescBlock)return;
	
	const ICaMethodDesc * const pCaMethodDesc = dynamic_cast<const ICaMethodDesc *>(pDescBlock->GetDescByTag(ICaMethodDesc::DESC_TAG));
	if(!pCaMethodDesc)return;

	const WORD wEcmPID = pCaMethodDesc->GetCaPID();
	if(wEcmPID >= TS_INVALID_PID)return;

	// ECMvZbTmF
	if(!m_TsPidMapper.GetMapTarget(wEcmPID)){
		// ECMvZbTPID}bvɒǉ
		m_TsPidMapper.MapPid(wEcmPID, dynamic_cast<ITsPidMapTarget *>(CEcmProcessor::CreateInstance(dynamic_cast<ITsDescrambler *>(this))));
		}

	// ESvZbTPID}bvɒǉ
	for(WORD wIndex = 0U ; wIndex < pPmtTable->GetEsNum() ; wIndex++){
		m_TsPidMapper.MapPid(pPmtTable->GetEsPID(wIndex), dynamic_cast<ITsPidMapTarget *>(CEsProcessor::CreateInstance(m_TsPidMapper.GetMapTarget(wEcmPID))));
		}
}

void CTsDescrambler::OnTotTable(const ITotTable *pTotTable)
{
	// Ȃ
}

void  CTsDescrambler::MapFixedTable(void)
{
	// SPIDA}bv
	m_TsPidMapper.ClearPid();

	// PATe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0000U, dynamic_cast<ITsPidMapTarget *>(CPatTable::CreateInstance(dynamic_cast<IPatTable::IHandler *>(this))));

	// CATe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0001U, dynamic_cast<ITsPidMapTarget *>(CCatTable::CreateInstance(dynamic_cast<ICatTable::IHandler *>(this))));

	// TOTe[uPID}bvɒǉ
	m_TsPidMapper.MapPid(0x0014U, dynamic_cast<ITsPidMapTarget *>(CTotTable::CreateInstance(dynamic_cast<ITotTable::IHandler *>(this))));
}


/////////////////////////////////////////////////////////////////////////////
// ECMNX
/////////////////////////////////////////////////////////////////////////////

void CTsDescrambler::CEcmProcessor::OnPidReset(ITsPidMapper *pTsPidMapper, const WORD wPID)
{
	// L[NA(L[ɂjh~邽)
	m_Multi2Decoder.SetScrambleKey(NULL);
	m_dwDescramblingState = IHalBcasCard::EC_NO_ERROR;
	
	CPsiTableBase::OnPidReset(pTsPidMapper, wPID);
}

CTsDescrambler::CEcmProcessor::CEcmProcessor(IBonObject * const pOwner)
	: CPsiTableBase(NULL)
	, m_pTsDescrambler(dynamic_cast<CTsDescrambler *>(pOwner))
	, m_pHalBcasCard(m_pTsDescrambler->m_pHalBcasCard)
	, m_dwLastRetryTime(::GetTickCount() - BCAS_REFRESH_INTERVAL)
	, m_dwDescramblingState(IHalBcasCard::EC_NO_ERROR)
{
	// MULTI2fR[_
	m_Multi2Decoder.Initialize(m_pHalBcasCard->GetSystemKey(), m_pHalBcasCard->GetInitialCbc());
}

CTsDescrambler::CEcmProcessor::~CEcmProcessor(void)
{
	// Ȃ
}

const bool CTsDescrambler::CEcmProcessor::DescramblePacket(ITsPacket * const pTsPacket)
{
	// IMediaDataC^tF[X₢킹
	IMediaData *pMediaData = dynamic_cast<IMediaData *>(pTsPacket);

	// XNu
	if(pMediaData){
		if(m_Multi2Decoder.Decode(pTsPacket->GetPayloadData(), (DWORD)pTsPacket->GetPayloadSize(), pTsPacket->m_Header.byTransportScramblingCtrl)){
			// gX|[gXNuĐݒ
			pMediaData->SetAt(3UL, pMediaData->GetAt(3UL) & 0x3FU);
			pTsPacket->m_Header.byTransportScramblingCtrl = 0U;

			return true;
			}
		}
	
	return false;
}

const bool CTsDescrambler::CEcmProcessor::OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection)
{
	// e[uID`FbN
	if(pNewSection->GetTableID() != TABLE_ID)return false;

	// ECMB-CASJ[hɓnăL[擾
	const BYTE *pKsData = m_pHalBcasCard->GetKsFromEcm(pNewSection->GetPayloadData(), pNewSection->GetPayloadSize());

	// ECMs͈xB-CASJ[hď
	if(!pKsData && (m_pHalBcasCard->GetEcmError() != IHalBcasCard::EC_NOT_CONTRACTED)){
		if((::GetTickCount() - m_dwLastRetryTime) >= BCAS_REFRESH_INTERVAL){
			// ďK[hC^[oo߂Ȃ			
			if(m_pHalBcasCard->OpenCard()){
				pKsData = m_pHalBcasCard->GetKsFromEcm(pNewSection->GetPayloadData(), pNewSection->GetPayloadSize());
				}
				
			// ŏIgCԍXV
			m_dwLastRetryTime = ::GetTickCount();
			}
		}

	// XNuL[XV
	m_Multi2Decoder.SetScrambleKey(pKsData);

	// Cxgʒm
	if(pKsData)CLIPED_INCREMENT(m_pTsDescrambler->m_dwEcmProcessNum);
	m_pTsDescrambler->SendDecoderEvent(EID_ECM_PROCESSED, reinterpret_cast<PVOID>(m_pHalBcasCard->GetEcmError()));

	// ԍXV
	m_dwDescramblingState = m_pHalBcasCard->GetEcmError();

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// EMMNX
/////////////////////////////////////////////////////////////////////////////

CTsDescrambler::CEmmProcessor::CEmmProcessor(IBonObject * const pOwner)
	: CPsiTableBase(NULL)
	, m_pTsDescrambler(dynamic_cast<CTsDescrambler *>(pOwner))
	, m_pHalBcasCard(m_pTsDescrambler->m_pHalBcasCard)
{
	// Ȃ
}

CTsDescrambler::CEmmProcessor::~CEmmProcessor(void)
{
	// Ȃ
}

const bool CTsDescrambler::CEmmProcessor::OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection)
{
	// e[uID`FbN
	if(pNewSection->GetTableID() != SECTION_TABLE_ID)return false;

	// EMM̂Ƃ͉Ȃ
	if(!m_pTsDescrambler->m_bEnableEmmProcess)return true;

	// ZNV
	const WORD wDataSize = pNewSection->GetPayloadSize();
	const BYTE *pHexData = pNewSection->GetPayloadData();
	
	WORD wPos = 0U;
	
	while((wDataSize - wPos) >= 17U){
		// EMMTCY`FbN
		const WORD wEmmSize = (WORD)pHexData[wPos + 6U] + 7U;
		if(((wDataSize - wPos) < wEmmSize) || (wEmmSize < 17U))break;

		// nhĂяo
		if(OnEmmBody(&pHexData[wPos], wEmmSize))break;
		
		// ͈ʒuXV
		wPos += wEmmSize;
		}

	return true;
}

const bool CTsDescrambler::CEmmProcessor::OnEmmBody(const BYTE *pEmmData, const WORD wEmmSize)
{
	// B-CASJ[hID擾
	const BYTE * const pCardID = m_pHalBcasCard->GetBcasCardID();

	// B-CASJ[hIDƏƍ
	for(DWORD dwPos = 0UL ; dwPos < 6UL ; dwPos++){
		if(pCardID[dwPos] != pEmmData[dwPos])return false;
		}

	// Xg[̎ԂmF
	CTsTime ValidTime;
	ValidTime.SetNowTime();									// ݎ擾
	ValidTime += EMM_VALID_PERIOD * 24UL * 60UL * 60UL;		// LԂߋɖ߂
	
	const ITotTable *pTotTable = dynamic_cast<const ITotTable *>(m_pTsDescrambler->m_TsPidMapper.GetMapTarget(0x0014U));
	if(!pTotTable)return true;
	CTsTime EmmTime = pTotTable->GetDateTime();				// TOT玞擾
	
	// LԂߋEMMf[^͏Ȃ
	if(EmmTime < ValidTime)return true;
	
	// B-CASJ[hEMMf[^M
	if(!m_pHalBcasCard->SendEmmSection(pEmmData, wEmmSize)){
		// gC
		if(!m_pHalBcasCard->SendEmmSection(pEmmData, wEmmSize)){
			// EMMs
			m_pTsDescrambler->SendDecoderEvent(EID_EMM_PROCESSED, reinterpret_cast<PVOID>(false));
			return true;
			}
		}

	// Cxgʒm
	CLIPED_INCREMENT(m_pTsDescrambler->m_dwEmmProcessNum);
	m_pTsDescrambler->SendDecoderEvent(EID_EMM_PROCESSED, reinterpret_cast<PVOID>(true));

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// ESNX
/////////////////////////////////////////////////////////////////////////////

CTsDescrambler::CEsProcessor::CEsProcessor(IBonObject * const pOwner)
	: CBonObject(NULL)
	, m_pEcmProcessor(dynamic_cast<CEcmProcessor *>(pOwner))
{
	// Ȃ
}

CTsDescrambler::CEsProcessor::~CEsProcessor(void)
{
	// Ȃ
}

const bool CTsDescrambler::CEsProcessor::StorePacket(const ITsPacket *pTsPacket)
{
	// XNu
	return m_pEcmProcessor->DescramblePacket(const_cast<ITsPacket *>(pTsPacket));
}

void CTsDescrambler::CEsProcessor::OnPidReset(ITsPidMapper *pTsPidMapper, const WORD wPID)
{
	// Ȃ
}

void CTsDescrambler::CEsProcessor::OnPidMapped(ITsPidMapper *pTsPidMapper, const WORD wPID)
{
	// Ȃ
}

void CTsDescrambler::CEsProcessor::OnPidUnmapped(ITsPidMapper *pTsPidMapper, const WORD wPID)
{
	// CX^XJ
	Release();
}
