// TsPacketSync.cpp: TSpPbgfR[_
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsPacketSync.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// t@C[J萔ݒ
/////////////////////////////////////////////////////////////////////////////

#define STRIDE_FILTER	10UL		// pPbgtB^
#define BITRATE_PERIOD	1000UL		// rbg[gXV(1000ms)

// NbvtCNg}N
#define CLIPED_INCREMENT(V)			{if((V) < 0xFFFFFFFFUL)(V)++;}


/////////////////////////////////////////////////////////////////////////////
// TSpPbgfR[_
/////////////////////////////////////////////////////////////////////////////

const bool CTsPacketSync::InputMedia(IMediaData *pMediaData, const DWORD dwInputIndex)
{
	// ̓p[^`FbN
	if(!pMediaData || (dwInputIndex > GetInputNum()))return false;

	// pPbg
	SyncPacket(pMediaData->GetData(), pMediaData->GetSize());

	return true;
}

void CTsPacketSync::DiscardNullPacket(const bool bEnable)
{
	// NULLpPbg̔jL/ݒ
	m_bDiscardNullPacket = (bEnable)? true : false;
}

void CTsPacketSync::ResetStatistics(void)
{
	// pPbgJE^Zbg
	m_dwCurStrideSize = 0UL;
	m_dwPrvStrideSize = 0UL;
	m_dwFixStrideSize = 0UL;
	m_dwFixStrideCount = 0UL;

	// vf[^Zbg
	m_dwInputPacketNum = 0UL;
	m_dwOutputPacketNum = 0UL;
	m_dwSyncErrNum = 0UL;
	m_dwFormatErrNum = 0UL;
	m_dwTransportErrNum = 0UL;
	m_dwContinuityErrNum = 0UL;
	m_LastUpdateTime = ::GetTickCount();
	m_LastInputPacket = 0UL;
	m_LastOutputPacket = 0UL;
	m_CurInputPacket = 0UL;
	m_CurOutputPacket = 0UL;

	// pPbgAJE^
	::FillMemory(m_abyContCounter, sizeof(m_abyContCounter), 0x10UL);
}

const DWORD CTsPacketSync::GetPacketStride(void) const
{
	// pPbgԂ
	return m_dwFixStrideCount;
}

const DWORD CTsPacketSync::GetInputPacketNum(void) const
{
	// ̓pPbgԂ(G[pPbgANULLpPbg܂)
	return m_dwInputPacketNum;
}

const DWORD CTsPacketSync::GetOutputPacketNum(void) const
{
	// o̓pPbgԂ(NULLpPbg)
	return m_dwOutputPacketNum;
}

const DWORD CTsPacketSync::GetInputBitrate(void) const
{
	// ̓rbg[gԂ(pPbgTCY~1bԂ̓̓pPbg~8bit)
	return m_LastInputPacket * TS_PACKET_SIZE * 8UL;
}

const DWORD CTsPacketSync::GetOutputBitrate(void) const
{
	// o̓rbg[gԂ(pPbgTCY~1bԂ̓̓pPbg~8bit)
	return m_LastInputPacket * TS_PACKET_SIZE * 8UL;
}

const DWORD CTsPacketSync::GetSyncErrNum(void) const
{
	// G[Ԃ(pPbgE郂[h)
	return m_dwSyncErrNum;
}

const DWORD CTsPacketSync::GetFormatErrNum(void) const
{
	// tH[}bgG[Ԃ(pPbgwb_KiÕ[h)
	return m_dwFormatErrNum;
}

const DWORD CTsPacketSync::GetTransportErrNum(void) const
{
	// gX|[gG[Ԃ(Transport Error Indicator[h)
	return m_dwTransportErrNum;
}

const DWORD CTsPacketSync::GetContinuityErrNum(void) const
{
	// AG[Ԃ(Continuity CountersAɂȂ郂[h)
	return m_dwContinuityErrNum;
}

CTsPacketSync::CTsPacketSync(IBonObject * const pOwner)
	: CMediaDecoder(pOwner, 1UL, 1UL)
	, m_TsPacket(NULL)
	, m_dwCurStrideSize(0UL)
	, m_dwPrvStrideSize(0UL)
	, m_dwFixStrideSize(0UL)
	, m_dwFixStrideCount(0UL)
	, m_bDiscardNullPacket(true)
	, m_dwInputPacketNum(0UL)
	, m_dwOutputPacketNum(0UL)
	, m_dwSyncErrNum(0UL)
	, m_dwFormatErrNum(0UL)
	, m_dwTransportErrNum(0UL)
	, m_dwContinuityErrNum(0UL)
	, m_LastUpdateTime(0UL)
	, m_LastInputPacket(0UL)
	, m_LastOutputPacket(0UL)
	, m_CurInputPacket(0UL)
	, m_CurOutputPacket(0UL)
{
	// vf[^
	ResetStatistics();
}

CTsPacketSync::~CTsPacketSync(void)
{
	// Ȃ
}

const bool CTsPacketSync::OnPlay(void)
{
	// Ԃ
	return OnReset();
}

const bool CTsPacketSync::OnReset(void)
{
	// pPbgTCYNA
	m_TsPacket.ClearSize();

	// vf[^Zbg
	ResetStatistics();
	
	return true;
}

void CTsPacketSync::SyncPacket(const BYTE *pStream, const DWORD dwSize)
{
	DWORD dwCurPos = 0UL;
	DWORD dwPrvPos;
	DWORD dwCurSize;

	while(dwCurPos < dwSize){
		dwCurSize = m_TsPacket.GetSize();
		dwPrvPos = dwCurPos;

		switch(dwCurSize){
			case 0UL :
				// oCg҂
				for( ; dwCurPos < dwSize ; dwCurPos++){
					if(pStream[dwCurPos] == 0x47U){
						// oCg
						m_TsPacket.AddByte(0x47U);
						dwCurPos++;
						break;
						}				
					}

				break;

			case TS_PACKET_SIZE :
				// pPbgTCYf[^Awb_
				if(ParseTsPacket()){
					// pPbg

					// G[
					if((m_dwFixStrideSize != m_dwCurStrideSize) && m_dwFixStrideSize){
						// pPbgُ
						CLIPED_INCREMENT(m_dwSyncErrNum);
						SendDecoderEvent(EID_SYNC_ERR, reinterpret_cast<PVOID>(m_dwSyncErrNum));
						}

					// pPbgtB^O
					if(m_dwCurStrideSize == m_dwPrvStrideSize){
						if(++m_dwFixStrideCount >= STRIDE_FILTER){
							// pPbgm
							m_dwFixStrideSize = m_dwCurStrideSize;
							m_dwFixStrideCount = STRIDE_FILTER;
							}
						}
					else{
						m_dwPrvStrideSize = m_dwCurStrideSize;
						m_dwFixStrideCount = 0UL;
						}
						

					// pPbgo
					OnTsPacket();

					// rbg[gXV
					UpdateBitrate();
					}
				else{
					// pPbgُAʒu߂ĉ͂𑱂
					if(dwCurPos >= (TS_PACKET_SIZE - 1UL))dwCurPos -= (TS_PACKET_SIZE - 1UL);
					else dwCurPos = 0UL;
					
					dwPrvPos = dwCurPos;
					}

				// pPbgTCYNA
				m_TsPacket.ClearSize();
				m_dwCurStrideSize = 0UL;

				break;

			default :
				// f[^҂
				if((dwSize - dwCurPos) >= (TS_PACKET_SIZE - dwCurSize)){
					m_TsPacket.AddData(&pStream[dwCurPos], TS_PACKET_SIZE - dwCurSize);
					dwCurPos += (TS_PACKET_SIZE - dwCurSize);
					}	
				else{
					m_TsPacket.AddData(&pStream[dwCurPos], dwSize - dwCurPos);
					dwCurPos += (dwSize - dwCurPos);
					}			
			
				break;
			}
		
		m_dwCurStrideSize += (dwCurPos - dwPrvPos);
		}
}

const bool CTsPacketSync::ParseTsPacket(void)
{
	// pPbg͂
	switch(m_TsPacket.ParsePacket(m_abyContCounter)){
		case ITsPacket::EC_VALID :
			// pPbg
			CLIPED_INCREMENT(m_dwInputPacketNum);
			CLIPED_INCREMENT(m_CurInputPacket);
			return true;

		case ITsPacket::EC_FORMAT :
			// tH[}bgُ
			CLIPED_INCREMENT(m_dwFormatErrNum);
			SendDecoderEvent(EID_FORMAT_ERR, reinterpret_cast<PVOID>(m_dwFormatErrNum));
			return false;
		
		case ITsPacket::EC_TRANSPORT :
			// gX|[gG[ُ
			CLIPED_INCREMENT(m_dwTransportErrNum);
			SendDecoderEvent(EID_TRANSPORT_ERR, reinterpret_cast<PVOID>(m_dwTransportErrNum));
			return false;
	
		case ITsPacket::EC_CONTINUITY :
			// Aُ(hbv)@pPbg̔j͂Ȃ
			CLIPED_INCREMENT(m_dwInputPacketNum);
			CLIPED_INCREMENT(m_dwContinuityErrNum);
			CLIPED_INCREMENT(m_CurInputPacket);
			SendDecoderEvent(EID_CONTINUITY_ERR, reinterpret_cast<PVOID>(m_dwContinuityErrNum));
			return true;
		
		default :
			// O
			::DebugBreak();
			return false;
		}
}

void CTsPacketSync::OnTsPacket(void)
{
	// pPbgo

	// NULLpPbg͔j
	if(m_bDiscardNullPacket && (m_TsPacket.GetPID() == 0x1FFFU))return;

	// o̓pPbgCNg
	CLIPED_INCREMENT(m_dwOutputPacketNum);
	CLIPED_INCREMENT(m_CurOutputPacket);
	
	// ʃfR[_Ƀf[^o
	OutputMedia(&m_TsPacket);
}

void CTsPacketSync::UpdateBitrate(void)
{
	// rbg[gXV
	const DWORD dwCurUpdateTime = ::GetTickCount();
	
	// XV`FbN
	if((dwCurUpdateTime - m_LastUpdateTime) < BITRATE_PERIOD)return;

	// JE^XV
	m_LastInputPacket = m_CurInputPacket;
	m_LastOutputPacket = m_CurOutputPacket;

	// JE^Zbg
	m_CurInputPacket = 0UL;
	m_CurOutputPacket = 0UL;
	
	// XV
	m_LastUpdateTime = dwCurUpdateTime;
}
