// TsPacketSync.h: TSpPbgfR[_
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "TsPacket.h"


/////////////////////////////////////////////////////////////////////////////
// TSpPbgfR[_
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: IMediaData	TSXg[
// Output	#0	: ITsPacket		TSpPbg
/////////////////////////////////////////////////////////////////////////////

class CTsPacketSync :	public CMediaDecoder,
						public ITsPacketSync
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CTsPacketSync)

// CMediaDecoder
	virtual const bool InputMedia(IMediaData *pMediaData, const DWORD dwInputIndex = 0UL);
	
// ITspacketSync
	virtual void DiscardNullPacket(const bool bEnable = true);
	virtual void ResetStatistics(void);
	virtual const DWORD GetPacketStride(void) const;
	virtual const DWORD GetInputPacketNum(void) const;
	virtual const DWORD GetOutputPacketNum(void) const;
	virtual const DWORD GetInputBitrate(void) const;
	virtual const DWORD GetOutputBitrate(void) const;
	virtual const DWORD GetSyncErrNum(void) const;
	virtual const DWORD GetFormatErrNum(void) const;
	virtual const DWORD GetTransportErrNum(void) const;
	virtual const DWORD GetContinuityErrNum(void) const;
	
// CTsPacketSync
	CTsPacketSync(IBonObject * const pOwner);
	virtual ~CTsPacketSync(void);
	
protected:
// CMediaDecoder
	virtual const bool OnPlay(void);
	virtual const bool OnReset(void);

// CTsPacketSync
	virtual void SyncPacket(const BYTE *pStream, const DWORD dwSize);
	virtual const bool ParseTsPacket(void);
	virtual void OnTsPacket(void);
	virtual void UpdateBitrate(void);
	
	CTsPacket m_TsPacket;

	BYTE m_abyContCounter[0x1FFF];

	DWORD m_dwCurStrideSize;
	DWORD m_dwPrvStrideSize;
	DWORD m_dwFixStrideSize;
	DWORD m_dwFixStrideCount;

	bool m_bDiscardNullPacket;

	DWORD m_dwInputPacketNum;
	DWORD m_dwOutputPacketNum;

	DWORD m_dwSyncErrNum;
	DWORD m_dwFormatErrNum;
	DWORD m_dwTransportErrNum;
	DWORD m_dwContinuityErrNum;

	DWORD m_LastUpdateTime;
	DWORD m_LastInputPacket;
	DWORD m_LastOutputPacket;
	DWORD m_CurInputPacket;
	DWORD m_CurOutputPacket;
};
