// TsPidMapper.cpp: PID}bpNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "PsiTableBase.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// PSIe[uNX
/////////////////////////////////////////////////////////////////////////////

const bool CPsiTableBase::StorePacket(const ITsPacket *pTsPacket)
{
	// pPbgp[Tɓ
	return m_SectionParser.StorePacket(pTsPacket);
}

void CPsiTableBase::OnPidReset(ITsPidMapper *pTsPidMapper, const WORD wPID)
{
	// ԂZbg
	Reset();
}

void CPsiTableBase::OnPidMapped(ITsPidMapper *pTsPidMapper, const WORD wPID)
{
	// QƃJE^CNg
	m_dwRefCount++;
	
	// Zbg
	Reset();
}

void CPsiTableBase::OnPidUnmapped(ITsPidMapper *pTsPidMapper, const WORD wPID)
{
	// QƃJE^fNg
	if(!(--m_dwRefCount))Release();
}

CPsiTableBase::CPsiTableBase(IBonObject * const pOwner)
	: CBonObject(pOwner)
	, m_SectionParser(dynamic_cast<IPsiSectionParser::IHandler *>(this))
	, m_LastSection(NULL)
	, m_dwRefCount(0UL)
{

}

CPsiTableBase::~CPsiTableBase(void)
{

}

void CPsiTableBase::Reset(void)
{
	// ԂZbg
	m_SectionParser.Reset();
	m_LastSection.Reset();
}

const DWORD CPsiTableBase::GetCrcErrorCount(void) const
{
	// CRCG[Ԃ
	return m_SectionParser.GetCrcErrorNum();
}

void CPsiTableBase::OnPsiSection(const IPsiSectionParser *pPsiSectionParser, const IPsiSection *pPsiSection)
{
	// ftHg̎ł̓ZNVyC[hXVɉz֐ɒʒm
	if(m_LastSection.CompareSection(pPsiSection)){
		// ZNVXVꂽ
		if(OnTableUpdate(pPsiSection, &m_LastSection)){
			// ZNVXgA
			m_LastSection.CopySection(pPsiSection);
			}
		}
}

const bool CPsiTableBase::OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection)
{
	// ftHg̎ł͉Ȃ
	return true;
}
