// TsDescriptor.h: fXNv^NX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "TsDescBase.h"


/////////////////////////////////////////////////////////////////////////////
// [0x09] Conditional Access Method LqqNX
/////////////////////////////////////////////////////////////////////////////

class CCaMethodDesc :	public CDescBase,
						public ICaMethodDesc
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CCaMethodDesc)

// ICaMethodDesc
	virtual const WORD GetCaMethodID(void) const;
	virtual const WORD GetCaPID(void) const;
	virtual const BYTE * GetPrivateData(void) const;
	virtual const BYTE GetPrivateDataSize(void) const;

// CCaMethodDesc
	CCaMethodDesc(IBonObject * const pOwner);
	virtual ~CCaMethodDesc(void);

protected:
// CDescBase
	virtual const bool ParseData(void);
};


/////////////////////////////////////////////////////////////////////////////
// [0x48] Service LqqNX
/////////////////////////////////////////////////////////////////////////////

class CServiceDesc :	public CDescBase,
						public IServiceDesc
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CServiceDesc)

// IServiceDesc
	virtual const BYTE GetServiceType(void) const;
	virtual const DWORD GetProviderName(LPTSTR lpszDst) const;
	virtual const DWORD GetServiceName(LPTSTR lpszDst) const;

// CServiceDesc
	CServiceDesc(IBonObject * const pOwner);
	virtual ~CServiceDesc(void);

protected:
// CDescBase
	virtual const bool ParseData(void);
};


/////////////////////////////////////////////////////////////////////////////
// [0x4D] Short Event LqqNX
/////////////////////////////////////////////////////////////////////////////

class CShortEventDesc :	public CDescBase,
						public IShortEventDesc
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CShortEventDesc)

// IShortEventDesc
	virtual const DWORD GetLanguageCode(void) const;
	virtual const DWORD GetEventName(LPTSTR lpszDst) const;
	virtual const DWORD GetEventDesc(LPTSTR lpszDst) const;

// CShortEventDesc
	CShortEventDesc(IBonObject * const pOwner);
	virtual ~CShortEventDesc(void);

protected:
// CDescBase
	virtual const bool ParseData(void);
};


/////////////////////////////////////////////////////////////////////////////
// [0x52] Stream Identifier LqqNX
/////////////////////////////////////////////////////////////////////////////

class CStreamIdDesc :	public CDescBase,
						public IStreamIdDesc
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CStreamIdDesc)

// IStreamIdDesc
	virtual const BYTE GetComponentTag(void) const;

// CStreamIdDesc
	CStreamIdDesc(IBonObject * const pOwner);
	virtual ~CStreamIdDesc(void);

protected:
// CDescBase
	virtual const bool ParseData(void);
};
