// TsTable.cpp: TSe[uNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "TsTable.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


/////////////////////////////////////////////////////////////////////////////
// [0x00] PATe[uNX
/////////////////////////////////////////////////////////////////////////////

void CPatTable::Reset(void)
{
	// ԂNA
	m_wTsID = 0x0000U;
	
	m_NitPIDArray.clear();
	m_PmtPIDArray.clear();

	CPsiTableBase::Reset();
}

const WORD CPatTable::GetTsID(void) const
{
	// TS IDԂ
	return m_wTsID;
}

const WORD CPatTable::GetNitPID(const WORD wIndex) const
{
	// NITPIDԂ
	return (wIndex < m_NitPIDArray.size())? m_NitPIDArray[wIndex].wPID : TS_INVALID_PID;
}

const WORD CPatTable::GetNitNum(void) const
{
	// NIT̐Ԃ
	return m_NitPIDArray.size();
}

const WORD CPatTable::GetPmtPID(const WORD wIndex) const
{
	// PMTPIDԂ
	return (wIndex < m_PmtPIDArray.size())? m_PmtPIDArray[wIndex].wPID : TS_INVALID_PID;
}

const WORD CPatTable::GetProgramID(const WORD wIndex) const
{
	// Program Number IDԂ
	return (wIndex < m_PmtPIDArray.size())? m_PmtPIDArray[wIndex].wProgramID : 0x0000U;
}

const WORD CPatTable::GetProgramNum(void) const
{
	// PMT̐Ԃ
	return m_PmtPIDArray.size();
}

CPatTable::CPatTable(IBonObject * const pOwner)
	: CPsiTableBase(pOwner)
	, m_pHandler(dynamic_cast<IPatTable::IHandler *>(pOwner))
	, m_wTsID(0UL)
{
	// Ȃ
}

CPatTable::~CPatTable(void)
{
	// Ȃ
}

const bool CPatTable::OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection)
{
	const WORD wDataSize = pNewSection->GetPayloadSize();
	const BYTE *pHexData = pNewSection->GetPayloadData();

	if(wDataSize % 4U)return false;										// e[ũTCYs
	if(pNewSection->GetTableID() != IPatTable::TABLE_ID)return false;	// e[uIDs

	// PIDNA
	m_NitPIDArray.clear();
	m_PmtPIDArray.clear();

	TAG_PATITEM PatItem;

	// e[u͂
	m_wTsID = pNewSection->GetTableIdExtension();

	TRACE(TEXT("\n------- PAT Table -------\nTS ID = %04X\n"), m_wTsID);

	for(WORD wPos = 0U ; wPos < wDataSize ; wPos += 4U, pHexData += 4){
		PatItem.wProgramID	= ((WORD)pHexData[0] << 8) | (WORD)pHexData[1];				// +1,2
		PatItem.wPID		= ((WORD)(pHexData[2] & 0x1FU) << 8) | (WORD)pHexData[3];	// +3,4

		if(!PatItem.wProgramID){
			// NITPID
			TRACE(TEXT("NIT #%u [ID:%04X][PID:%04X]\n"), m_NitPIDArray.size(), PatItem.wProgramID, PatItem.wPID);
			m_NitPIDArray.push_back(PatItem);
			}
		else{
			// PMTPID
			TRACE(TEXT("PMT #%u [ID:%04X][PID:%04X]\n"), m_PmtPIDArray.size(), PatItem.wProgramID, PatItem.wPID);
			m_PmtPIDArray.push_back(PatItem);
			}
		}

	// nh֒ʒm
	if(m_pHandler)m_pHandler->OnPatTable(this);

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// [0x01] CATe[uNX
/////////////////////////////////////////////////////////////////////////////

void CCatTable::Reset(void)
{
	// ԂNA
	m_DescBlock.Reset();

	CPsiTableBase::Reset();
}

const IDescBlock * CCatTable::GetCatDesc(void) const
{
	// Lqq̈Ԃ
	return &m_DescBlock;
}

CCatTable::CCatTable(IBonObject * const pOwner)
	: CPsiTableBase(pOwner)
	, m_DescBlock(NULL)
	, m_pHandler(dynamic_cast<ICatTable::IHandler *>(pOwner))
{
	// Ȃ
}

CCatTable::~CCatTable(void)
{
	// Ȃ
}

const bool CCatTable::OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection)
{
	if(pNewSection->GetTableID() != ICatTable::TABLE_ID)return false;	// e[uIDs
	
	// e[u͂
	m_DescBlock.SetData(pNewSection->GetPayloadData(), pNewSection->GetPayloadSize());
	m_DescBlock.ParseDescs();

	TRACE(TEXT("\n------- CAT Table -------\n"));

	for(DWORD dwIndex = 0UL ; dwIndex < m_DescBlock.GetDescNum() ; dwIndex++){
		const IDescBase *pDescBase = m_DescBlock.GetDescByIndex(dwIndex);
		TRACE(TEXT("[%lu] TAG = 0x%02X LEN = %lu\n"), dwIndex, pDescBase->GetTag(), pDescBase->GetLength());
		}

	// nh֒ʒm
	if(m_pHandler)m_pHandler->OnCatTable(this);

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// [0x02] PMTe[uNX
/////////////////////////////////////////////////////////////////////////////

void CPmtTable::Reset(void)
{
	// ԂNA
	m_wProgramID = 0x0000U;
	m_wPcrPID = TS_INVALID_PID;
	m_DescBlock.Reset();

	for(DWORD dwIndex = 0UL ; dwIndex < m_EsInfoArray.size() ; dwIndex++){
		if(m_EsInfoArray[dwIndex].pDescBlock)m_EsInfoArray[dwIndex].pDescBlock->Release();
		}

	m_EsInfoArray.clear();
	
	CPsiTableBase::Reset();
}

const WORD CPmtTable::GetProgramID(void) const
{
	// ԑgԍIDԂ
	return m_wProgramID;
}

const WORD CPmtTable::GetPcrPID(void) const
{
	// PCR PIDԂ
	return m_wPcrPID;
}

const IDescBlock * CPmtTable::GetPmtDesc(void) const
{
	// Lqq̈1Ԃ
	return &m_DescBlock;
}

const WORD CPmtTable::GetEsNum(void) const
{
	// G^Xg[Ԃ
	return m_EsInfoArray.size();
}

const BYTE CPmtTable::GetStreamTypeID(const WORD wIndex) const
{
	// Xg[`IDԂ
	return (wIndex < m_EsInfoArray.size())? m_EsInfoArray[wIndex].byStreamTypeID : 0x00U;
}

const WORD CPmtTable::GetEsPID(const WORD wIndex) const
{
	// G^PIDԂ
	return (wIndex < m_EsInfoArray.size())? m_EsInfoArray[wIndex].wEsPID : TS_INVALID_PID;
}

const IDescBlock * CPmtTable::GetEsDesc(const WORD wIndex) const
{
	// Lqq̈2Ԃ
	return (wIndex < m_EsInfoArray.size())? m_EsInfoArray[wIndex].pDescBlock : NULL;
}

CPmtTable::CPmtTable(IBonObject * const pOwner)
	: CPsiTableBase(pOwner)
	, m_wProgramID(0x0000U)
	, m_wPcrPID(TS_INVALID_PID)
	, m_DescBlock(NULL)
	, m_pHandler(dynamic_cast<IPmtTable::IHandler *>(pOwner))
{
	// Ȃ
}

CPmtTable::~CPmtTable(void)
{
	// CX^XJ
	Reset();
}

const bool CPmtTable::OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection)
{
	const WORD wDataSize = pNewSection->GetPayloadSize();
	const BYTE *pHexData = pNewSection->GetPayloadData();

	if(pNewSection->GetTableID() != IPmtTable::TABLE_ID)return false;	// e[uIDs
	
	// ESNA
	for(DWORD dwIndex = 0UL ; dwIndex < m_EsInfoArray.size() ; dwIndex++){
		if(m_EsInfoArray[dwIndex].pDescBlock)m_EsInfoArray[dwIndex].pDescBlock->Release();
		}

	m_EsInfoArray.clear();
	
	// e[u͂
	m_wProgramID = pNewSection->GetTableIdExtension();
	m_wPcrPID = ((WORD)(pHexData[0] & 0x1FU) << 8) | (WORD)pHexData[1];

	WORD wDescLen = ((WORD)(pHexData[2] & 0x0FU) << 8) | (WORD)pHexData[3];
	m_DescBlock.SetData(&pHexData[4], wDescLen);
	m_DescBlock.ParseDescs();

	TRACE(TEXT("\n------- PMT Table -------\nProgram Number ID = %04X\nPCR PID = %04X\nECM PID = %04X\nDescriptor Field:\n"), m_wProgramID, m_wPcrPID, (m_DescBlock.GetDescByTag(CCaMethodDesc::DESC_TAG))? dynamic_cast<const CCaMethodDesc *>(m_DescBlock.GetDescByTag(CCaMethodDesc::DESC_TAG))->GetCaPID() : TS_INVALID_PID);

	for(DWORD dwIndex = 0UL ; dwIndex < m_DescBlock.GetDescNum() ; dwIndex++){
		const IDescBase *pDescBase = m_DescBlock.GetDescByIndex(dwIndex);
		TRACE(TEXT("    [%lu] TAG = 0x%02X LEN = %lu\n"), dwIndex, pDescBase->GetTag(), pDescBase->GetLength());
		}

	// Xg[̊JnʒuvZ
	WORD wPos = wDescLen + 4U;
	TAG_PMTITEM PmtItem;

	// ES
	while(wPos < wDataSize){
		PmtItem.byStreamTypeID = pHexData[wPos + 0U];													// +0
		PmtItem.wEsPID = ((WORD)(pHexData[wPos + 1U] & 0x1FU) << 8) | (WORD)pHexData[wPos + 2U];		// +1,2	
		wDescLen = ((WORD)(pHexData[wPos + 3U] & 0x0FU) << 8) | (WORD)pHexData[wPos + 4U];				// +3,4

		// LqqubN
		PmtItem.pDescBlock = dynamic_cast<CDescBlock *>(CDescBlock::CreateInstance(NULL));
		PmtItem.pDescBlock->SetData(&pHexData[wPos + 5U], wDescLen);
		PmtItem.pDescBlock->ParseDescs();

		TRACE(TEXT("[%u] Stream Type ID = %02X  PID = %04X\n"), m_EsInfoArray.size(), PmtItem.byStreamTypeID, PmtItem.wEsPID);		

		for(DWORD dwIndex = 0UL ; dwIndex < PmtItem.pDescBlock->GetDescNum() ; dwIndex++){
			const IDescBase *pDescBase = PmtItem.pDescBlock->GetDescByIndex(dwIndex);
			TRACE(TEXT("    [%lu] TAG = 0x%02X LEN = %lu\n"), dwIndex, pDescBase->GetTag(), pDescBase->GetLength());
			}

		// e[uɒǉ
		m_EsInfoArray.push_back(PmtItem);
		wPos += (wDescLen + 5U);
		}

	// nh֒ʒm
	if(m_pHandler)m_pHandler->OnPmtTable(this);

	return true;
}


/////////////////////////////////////////////////////////////////////////////
// [0x73] TOTe[uNX
/////////////////////////////////////////////////////////////////////////////

void CTotTable::Reset(void)
{
	// ԂNA
	m_DateTime.ClearTime();
	m_DescBlock.Reset();
	
	CPsiTableBase::Reset();
}

const SYSTEMTIME & CTotTable::GetDateTime(void) const
{
	// ݓt/Ԃ
	return m_DateTime;
}

const IDescBlock * CTotTable::GetTotDesc(void) const
{
	// Lqq̈Ԃ
	return &m_DescBlock;
}

CTotTable::CTotTable(IBonObject * const pOwner)
	: CPsiTableBase(pOwner)
	, m_DescBlock(NULL)
	, m_pHandler(dynamic_cast<ITotTable::IHandler *>(pOwner))
{
	// W`ZNVI
	m_SectionParser.SetExtSection(false);
}

CTotTable::~CTotTable(void)
{
	// Ȃ
}

const bool CTotTable::OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection)
{
	const WORD wDataSize = pNewSection->GetPayloadSize();
	const BYTE *pHexData = pNewSection->GetPayloadData();

	if(pNewSection->GetTableID() != ITotTable::TABLE_ID)return false;	// e[uIDs

	// e[u͂
	m_DateTime.SetAribTime(pHexData);
	
	const WORD wDescLen = ((WORD)(pHexData[5] & 0x0FU) << 8) | (WORD)pHexData[6];
	m_DescBlock.SetData(&pHexData[7], wDescLen);
	m_DescBlock.ParseDescs();

	// nh֒ʒm
	if(m_pHandler)m_pHandler->OnTotTable(this);

	return true;
}
