// TsTable.h: TSe[uNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include <Vector>
#include "PsiSection.h"
#include "PsiTableBase.h"
#include "TsDescBase.h"
#include "TsDescriptor.h"
#include "TsDataEncode.h"


/////////////////////////////////////////////////////////////////////////////
// [0x00] PATe[uNX
/////////////////////////////////////////////////////////////////////////////

class CPatTable :	public CPsiTableBase,
					public IPatTable
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CPatTable)

// CPsiTableBase
	virtual void Reset(void);

// IPatTable
	virtual const WORD GetTsID(void) const;
	virtual const WORD GetNitPID(const WORD wIndex = 0U) const;
	virtual const WORD GetNitNum(void) const;
	virtual const WORD GetPmtPID(const WORD wIndex = 0U) const;
	virtual const WORD GetProgramID(const WORD wIndex = 0U) const;
	virtual const WORD GetProgramNum(void) const;

// CPatTable
	CPatTable(IBonObject * const pOwner);
	virtual ~CPatTable(void);

protected:
// CPsiTableBase
	virtual const bool OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection);

	struct TAG_PATITEM
	{
		WORD wProgramID;	// ԑgԍID
		WORD wPID;			// NIT or PMTPID
	};

	WORD m_wTsID;			// TS ID

	std::vector<TAG_PATITEM> m_NitPIDArray;
	std::vector<TAG_PATITEM> m_PmtPIDArray;

	IPatTable::IHandler * const m_pHandler;
};


/////////////////////////////////////////////////////////////////////////////
// [0x01] CATe[uNX
/////////////////////////////////////////////////////////////////////////////

class CCatTable :	public CPsiTableBase,
					public ICatTable
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CCatTable)

// CPsiTableBase
	virtual void Reset(void);

// ICatTable
	virtual const IDescBlock * GetCatDesc(void) const;

// CCatTable
	CCatTable(IBonObject * const pOwner);
	virtual ~CCatTable(void);

protected:
// CPsiTableBase
	virtual const bool OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection);

	CDescBlock m_DescBlock;		// Lqq̈

	ICatTable::IHandler * const m_pHandler;
};


/////////////////////////////////////////////////////////////////////////////
// [0x02] PMTe[uNX
/////////////////////////////////////////////////////////////////////////////

class CPmtTable :	public CPsiTableBase,
					public IPmtTable
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CPmtTable)

// CPsiTableBase
	virtual void Reset(void);

// IPmtTable
	virtual const WORD GetProgramID(void) const;
	virtual const WORD GetPcrPID(void) const;
	virtual const IDescBlock * GetPmtDesc(void) const;
	virtual const WORD GetEsNum(void) const;
	virtual const BYTE GetStreamTypeID(const WORD wIndex) const;
	virtual const WORD GetEsPID(const WORD wIndex) const;
	virtual const IDescBlock * GetEsDesc(const WORD wIndex) const;

// CPmtTable
	CPmtTable(IBonObject * const pOwner);
	virtual ~CPmtTable(void);

protected:
// CPsiTableBase
	virtual const bool OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection);

	struct TAG_PMTITEM
	{
		BYTE byStreamTypeID;		// Xg[`ID
		WORD wEsPID;				// G^PID
		CDescBlock *pDescBlock;		// Lqq̈2
	};

	WORD m_wProgramID;				// ԑgԍID
	WORD m_wPcrPID;					// PCR PID
	CDescBlock m_DescBlock;			// Lqq̈1

	std::vector<TAG_PMTITEM> m_EsInfoArray;

	IPmtTable::IHandler * const m_pHandler;
};


/////////////////////////////////////////////////////////////////////////////
// [0x73] TOTe[uNX
/////////////////////////////////////////////////////////////////////////////

class CTotTable :	public CPsiTableBase,
					public ITotTable
{
public:
// CBonObject
	DECLARE_IBONOBJECT(CTotTable)

// CPsiTableBase
	virtual void Reset(void);

// ITotTable
	virtual const SYSTEMTIME & GetDateTime(void) const;
	virtual const IDescBlock * GetTotDesc(void) const;
	
// CTotTable
	CTotTable(IBonObject * const pOwner);
	virtual ~CTotTable(void);

protected:
// CPsiTableBase
	virtual const bool OnTableUpdate(const IPsiSection *pNewSection, const IPsiSection *pLastSection);

	CTsTime m_DateTime;			// ݓt/
	CDescBlock m_DescBlock;		// Lqq̈

	ITotTable::IHandler * const m_pHandler;
};